import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_GetGatewayResponsesCommand, se_GetGatewayResponsesCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class GetGatewayResponsesCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("BackplaneControlService", "GetGatewayResponses", {})
    .n("APIGatewayClient", "GetGatewayResponsesCommand")
    .f(void 0, void 0)
    .ser(se_GetGatewayResponsesCommand)
    .de(de_GetGatewayResponsesCommand)
    .build() {
}
