import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { de_UpdateAccountCommand, se_UpdateAccountCommand } from "../protocols/Aws_restJson1";
export { $Command };
export class UpdateAccountCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("BackplaneControlService", "UpdateAccount", {})
    .n("APIGatewayClient", "UpdateAccountCommand")
    .f(void 0, void 0)
    .ser(se_UpdateAccountCommand)
    .de(de_UpdateAccountCommand)
    .build() {
}
