import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import { CreateApiKeyCommandInput, CreateApiKeyCommandOutput } from "../commands/CreateApiKeyCommand";
import { CreateAuthorizerCommandInput, CreateAuthorizerCommandOutput } from "../commands/CreateAuthorizerCommand";
import { CreateBasePathMappingCommandInput, CreateBasePathMappingCommandOutput } from "../commands/CreateBasePathMappingCommand";
import { CreateDeploymentCommandInput, CreateDeploymentCommandOutput } from "../commands/CreateDeploymentCommand";
import { CreateDocumentationPartCommandInput, CreateDocumentationPartCommandOutput } from "../commands/CreateDocumentationPartCommand";
import { CreateDocumentationVersionCommandInput, CreateDocumentationVersionCommandOutput } from "../commands/CreateDocumentationVersionCommand";
import { CreateDomainNameAccessAssociationCommandInput, CreateDomainNameAccessAssociationCommandOutput } from "../commands/CreateDomainNameAccessAssociationCommand";
import { CreateDomainNameCommandInput, CreateDomainNameCommandOutput } from "../commands/CreateDomainNameCommand";
import { CreateModelCommandInput, CreateModelCommandOutput } from "../commands/CreateModelCommand";
import { CreateRequestValidatorCommandInput, CreateRequestValidatorCommandOutput } from "../commands/CreateRequestValidatorCommand";
import { CreateResourceCommandInput, CreateResourceCommandOutput } from "../commands/CreateResourceCommand";
import { CreateRestApiCommandInput, CreateRestApiCommandOutput } from "../commands/CreateRestApiCommand";
import { CreateStageCommandInput, CreateStageCommandOutput } from "../commands/CreateStageCommand";
import { CreateUsagePlanCommandInput, CreateUsagePlanCommandOutput } from "../commands/CreateUsagePlanCommand";
import { CreateUsagePlanKeyCommandInput, CreateUsagePlanKeyCommandOutput } from "../commands/CreateUsagePlanKeyCommand";
import { CreateVpcLinkCommandInput, CreateVpcLinkCommandOutput } from "../commands/CreateVpcLinkCommand";
import { DeleteApiKeyCommandInput, DeleteApiKeyCommandOutput } from "../commands/DeleteApiKeyCommand";
import { DeleteAuthorizerCommandInput, DeleteAuthorizerCommandOutput } from "../commands/DeleteAuthorizerCommand";
import { DeleteBasePathMappingCommandInput, DeleteBasePathMappingCommandOutput } from "../commands/DeleteBasePathMappingCommand";
import { DeleteClientCertificateCommandInput, DeleteClientCertificateCommandOutput } from "../commands/DeleteClientCertificateCommand";
import { DeleteDeploymentCommandInput, DeleteDeploymentCommandOutput } from "../commands/DeleteDeploymentCommand";
import { DeleteDocumentationPartCommandInput, DeleteDocumentationPartCommandOutput } from "../commands/DeleteDocumentationPartCommand";
import { DeleteDocumentationVersionCommandInput, DeleteDocumentationVersionCommandOutput } from "../commands/DeleteDocumentationVersionCommand";
import { DeleteDomainNameAccessAssociationCommandInput, DeleteDomainNameAccessAssociationCommandOutput } from "../commands/DeleteDomainNameAccessAssociationCommand";
import { DeleteDomainNameCommandInput, DeleteDomainNameCommandOutput } from "../commands/DeleteDomainNameCommand";
import { DeleteGatewayResponseCommandInput, DeleteGatewayResponseCommandOutput } from "../commands/DeleteGatewayResponseCommand";
import { DeleteIntegrationCommandInput, DeleteIntegrationCommandOutput } from "../commands/DeleteIntegrationCommand";
import { DeleteIntegrationResponseCommandInput, DeleteIntegrationResponseCommandOutput } from "../commands/DeleteIntegrationResponseCommand";
import { DeleteMethodCommandInput, DeleteMethodCommandOutput } from "../commands/DeleteMethodCommand";
import { DeleteMethodResponseCommandInput, DeleteMethodResponseCommandOutput } from "../commands/DeleteMethodResponseCommand";
import { DeleteModelCommandInput, DeleteModelCommandOutput } from "../commands/DeleteModelCommand";
import { DeleteRequestValidatorCommandInput, DeleteRequestValidatorCommandOutput } from "../commands/DeleteRequestValidatorCommand";
import { DeleteResourceCommandInput, DeleteResourceCommandOutput } from "../commands/DeleteResourceCommand";
import { DeleteRestApiCommandInput, DeleteRestApiCommandOutput } from "../commands/DeleteRestApiCommand";
import { DeleteStageCommandInput, DeleteStageCommandOutput } from "../commands/DeleteStageCommand";
import { DeleteUsagePlanCommandInput, DeleteUsagePlanCommandOutput } from "../commands/DeleteUsagePlanCommand";
import { DeleteUsagePlanKeyCommandInput, DeleteUsagePlanKeyCommandOutput } from "../commands/DeleteUsagePlanKeyCommand";
import { DeleteVpcLinkCommandInput, DeleteVpcLinkCommandOutput } from "../commands/DeleteVpcLinkCommand";
import { FlushStageAuthorizersCacheCommandInput, FlushStageAuthorizersCacheCommandOutput } from "../commands/FlushStageAuthorizersCacheCommand";
import { FlushStageCacheCommandInput, FlushStageCacheCommandOutput } from "../commands/FlushStageCacheCommand";
import { GenerateClientCertificateCommandInput, GenerateClientCertificateCommandOutput } from "../commands/GenerateClientCertificateCommand";
import { GetAccountCommandInput, GetAccountCommandOutput } from "../commands/GetAccountCommand";
import { GetApiKeyCommandInput, GetApiKeyCommandOutput } from "../commands/GetApiKeyCommand";
import { GetApiKeysCommandInput, GetApiKeysCommandOutput } from "../commands/GetApiKeysCommand";
import { GetAuthorizerCommandInput, GetAuthorizerCommandOutput } from "../commands/GetAuthorizerCommand";
import { GetAuthorizersCommandInput, GetAuthorizersCommandOutput } from "../commands/GetAuthorizersCommand";
import { GetBasePathMappingCommandInput, GetBasePathMappingCommandOutput } from "../commands/GetBasePathMappingCommand";
import { GetBasePathMappingsCommandInput, GetBasePathMappingsCommandOutput } from "../commands/GetBasePathMappingsCommand";
import { GetClientCertificateCommandInput, GetClientCertificateCommandOutput } from "../commands/GetClientCertificateCommand";
import { GetClientCertificatesCommandInput, GetClientCertificatesCommandOutput } from "../commands/GetClientCertificatesCommand";
import { GetDeploymentCommandInput, GetDeploymentCommandOutput } from "../commands/GetDeploymentCommand";
import { GetDeploymentsCommandInput, GetDeploymentsCommandOutput } from "../commands/GetDeploymentsCommand";
import { GetDocumentationPartCommandInput, GetDocumentationPartCommandOutput } from "../commands/GetDocumentationPartCommand";
import { GetDocumentationPartsCommandInput, GetDocumentationPartsCommandOutput } from "../commands/GetDocumentationPartsCommand";
import { GetDocumentationVersionCommandInput, GetDocumentationVersionCommandOutput } from "../commands/GetDocumentationVersionCommand";
import { GetDocumentationVersionsCommandInput, GetDocumentationVersionsCommandOutput } from "../commands/GetDocumentationVersionsCommand";
import { GetDomainNameAccessAssociationsCommandInput, GetDomainNameAccessAssociationsCommandOutput } from "../commands/GetDomainNameAccessAssociationsCommand";
import { GetDomainNameCommandInput, GetDomainNameCommandOutput } from "../commands/GetDomainNameCommand";
import { GetDomainNamesCommandInput, GetDomainNamesCommandOutput } from "../commands/GetDomainNamesCommand";
import { GetExportCommandInput, GetExportCommandOutput } from "../commands/GetExportCommand";
import { GetGatewayResponseCommandInput, GetGatewayResponseCommandOutput } from "../commands/GetGatewayResponseCommand";
import { GetGatewayResponsesCommandInput, GetGatewayResponsesCommandOutput } from "../commands/GetGatewayResponsesCommand";
import { GetIntegrationCommandInput, GetIntegrationCommandOutput } from "../commands/GetIntegrationCommand";
import { GetIntegrationResponseCommandInput, GetIntegrationResponseCommandOutput } from "../commands/GetIntegrationResponseCommand";
import { GetMethodCommandInput, GetMethodCommandOutput } from "../commands/GetMethodCommand";
import { GetMethodResponseCommandInput, GetMethodResponseCommandOutput } from "../commands/GetMethodResponseCommand";
import { GetModelCommandInput, GetModelCommandOutput } from "../commands/GetModelCommand";
import { GetModelsCommandInput, GetModelsCommandOutput } from "../commands/GetModelsCommand";
import { GetModelTemplateCommandInput, GetModelTemplateCommandOutput } from "../commands/GetModelTemplateCommand";
import { GetRequestValidatorCommandInput, GetRequestValidatorCommandOutput } from "../commands/GetRequestValidatorCommand";
import { GetRequestValidatorsCommandInput, GetRequestValidatorsCommandOutput } from "../commands/GetRequestValidatorsCommand";
import { GetResourceCommandInput, GetResourceCommandOutput } from "../commands/GetResourceCommand";
import { GetResourcesCommandInput, GetResourcesCommandOutput } from "../commands/GetResourcesCommand";
import { GetRestApiCommandInput, GetRestApiCommandOutput } from "../commands/GetRestApiCommand";
import { GetRestApisCommandInput, GetRestApisCommandOutput } from "../commands/GetRestApisCommand";
import { GetSdkCommandInput, GetSdkCommandOutput } from "../commands/GetSdkCommand";
import { GetSdkTypeCommandInput, GetSdkTypeCommandOutput } from "../commands/GetSdkTypeCommand";
import { GetSdkTypesCommandInput, GetSdkTypesCommandOutput } from "../commands/GetSdkTypesCommand";
import { GetStageCommandInput, GetStageCommandOutput } from "../commands/GetStageCommand";
import { GetStagesCommandInput, GetStagesCommandOutput } from "../commands/GetStagesCommand";
import { GetTagsCommandInput, GetTagsCommandOutput } from "../commands/GetTagsCommand";
import { GetUsageCommandInput, GetUsageCommandOutput } from "../commands/GetUsageCommand";
import { GetUsagePlanCommandInput, GetUsagePlanCommandOutput } from "../commands/GetUsagePlanCommand";
import { GetUsagePlanKeyCommandInput, GetUsagePlanKeyCommandOutput } from "../commands/GetUsagePlanKeyCommand";
import { GetUsagePlanKeysCommandInput, GetUsagePlanKeysCommandOutput } from "../commands/GetUsagePlanKeysCommand";
import { GetUsagePlansCommandInput, GetUsagePlansCommandOutput } from "../commands/GetUsagePlansCommand";
import { GetVpcLinkCommandInput, GetVpcLinkCommandOutput } from "../commands/GetVpcLinkCommand";
import { GetVpcLinksCommandInput, GetVpcLinksCommandOutput } from "../commands/GetVpcLinksCommand";
import { ImportApiKeysCommandInput, ImportApiKeysCommandOutput } from "../commands/ImportApiKeysCommand";
import { ImportDocumentationPartsCommandInput, ImportDocumentationPartsCommandOutput } from "../commands/ImportDocumentationPartsCommand";
import { ImportRestApiCommandInput, ImportRestApiCommandOutput } from "../commands/ImportRestApiCommand";
import { PutGatewayResponseCommandInput, PutGatewayResponseCommandOutput } from "../commands/PutGatewayResponseCommand";
import { PutIntegrationCommandInput, PutIntegrationCommandOutput } from "../commands/PutIntegrationCommand";
import { PutIntegrationResponseCommandInput, PutIntegrationResponseCommandOutput } from "../commands/PutIntegrationResponseCommand";
import { PutMethodCommandInput, PutMethodCommandOutput } from "../commands/PutMethodCommand";
import { PutMethodResponseCommandInput, PutMethodResponseCommandOutput } from "../commands/PutMethodResponseCommand";
import { PutRestApiCommandInput, PutRestApiCommandOutput } from "../commands/PutRestApiCommand";
import { RejectDomainNameAccessAssociationCommandInput, RejectDomainNameAccessAssociationCommandOutput } from "../commands/RejectDomainNameAccessAssociationCommand";
import { TagResourceCommandInput, TagResourceCommandOutput } from "../commands/TagResourceCommand";
import { TestInvokeAuthorizerCommandInput, TestInvokeAuthorizerCommandOutput } from "../commands/TestInvokeAuthorizerCommand";
import { TestInvokeMethodCommandInput, TestInvokeMethodCommandOutput } from "../commands/TestInvokeMethodCommand";
import { UntagResourceCommandInput, UntagResourceCommandOutput } from "../commands/UntagResourceCommand";
import { UpdateAccountCommandInput, UpdateAccountCommandOutput } from "../commands/UpdateAccountCommand";
import { UpdateApiKeyCommandInput, UpdateApiKeyCommandOutput } from "../commands/UpdateApiKeyCommand";
import { UpdateAuthorizerCommandInput, UpdateAuthorizerCommandOutput } from "../commands/UpdateAuthorizerCommand";
import { UpdateBasePathMappingCommandInput, UpdateBasePathMappingCommandOutput } from "../commands/UpdateBasePathMappingCommand";
import { UpdateClientCertificateCommandInput, UpdateClientCertificateCommandOutput } from "../commands/UpdateClientCertificateCommand";
import { UpdateDeploymentCommandInput, UpdateDeploymentCommandOutput } from "../commands/UpdateDeploymentCommand";
import { UpdateDocumentationPartCommandInput, UpdateDocumentationPartCommandOutput } from "../commands/UpdateDocumentationPartCommand";
import { UpdateDocumentationVersionCommandInput, UpdateDocumentationVersionCommandOutput } from "../commands/UpdateDocumentationVersionCommand";
import { UpdateDomainNameCommandInput, UpdateDomainNameCommandOutput } from "../commands/UpdateDomainNameCommand";
import { UpdateGatewayResponseCommandInput, UpdateGatewayResponseCommandOutput } from "../commands/UpdateGatewayResponseCommand";
import { UpdateIntegrationCommandInput, UpdateIntegrationCommandOutput } from "../commands/UpdateIntegrationCommand";
import { UpdateIntegrationResponseCommandInput, UpdateIntegrationResponseCommandOutput } from "../commands/UpdateIntegrationResponseCommand";
import { UpdateMethodCommandInput, UpdateMethodCommandOutput } from "../commands/UpdateMethodCommand";
import { UpdateMethodResponseCommandInput, UpdateMethodResponseCommandOutput } from "../commands/UpdateMethodResponseCommand";
import { UpdateModelCommandInput, UpdateModelCommandOutput } from "../commands/UpdateModelCommand";
import { UpdateRequestValidatorCommandInput, UpdateRequestValidatorCommandOutput } from "../commands/UpdateRequestValidatorCommand";
import { UpdateResourceCommandInput, UpdateResourceCommandOutput } from "../commands/UpdateResourceCommand";
import { UpdateRestApiCommandInput, UpdateRestApiCommandOutput } from "../commands/UpdateRestApiCommand";
import { UpdateStageCommandInput, UpdateStageCommandOutput } from "../commands/UpdateStageCommand";
import { UpdateUsageCommandInput, UpdateUsageCommandOutput } from "../commands/UpdateUsageCommand";
import { UpdateUsagePlanCommandInput, UpdateUsagePlanCommandOutput } from "../commands/UpdateUsagePlanCommand";
import { UpdateVpcLinkCommandInput, UpdateVpcLinkCommandOutput } from "../commands/UpdateVpcLinkCommand";
/**
 * serializeAws_restJson1CreateApiKeyCommand
 */
export declare const se_CreateApiKeyCommand: (input: CreateApiKeyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateAuthorizerCommand
 */
export declare const se_CreateAuthorizerCommand: (input: CreateAuthorizerCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateBasePathMappingCommand
 */
export declare const se_CreateBasePathMappingCommand: (input: CreateBasePathMappingCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateDeploymentCommand
 */
export declare const se_CreateDeploymentCommand: (input: CreateDeploymentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateDocumentationPartCommand
 */
export declare const se_CreateDocumentationPartCommand: (input: CreateDocumentationPartCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateDocumentationVersionCommand
 */
export declare const se_CreateDocumentationVersionCommand: (input: CreateDocumentationVersionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateDomainNameCommand
 */
export declare const se_CreateDomainNameCommand: (input: CreateDomainNameCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateDomainNameAccessAssociationCommand
 */
export declare const se_CreateDomainNameAccessAssociationCommand: (input: CreateDomainNameAccessAssociationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateModelCommand
 */
export declare const se_CreateModelCommand: (input: CreateModelCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateRequestValidatorCommand
 */
export declare const se_CreateRequestValidatorCommand: (input: CreateRequestValidatorCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateResourceCommand
 */
export declare const se_CreateResourceCommand: (input: CreateResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateRestApiCommand
 */
export declare const se_CreateRestApiCommand: (input: CreateRestApiCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateStageCommand
 */
export declare const se_CreateStageCommand: (input: CreateStageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateUsagePlanCommand
 */
export declare const se_CreateUsagePlanCommand: (input: CreateUsagePlanCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateUsagePlanKeyCommand
 */
export declare const se_CreateUsagePlanKeyCommand: (input: CreateUsagePlanKeyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1CreateVpcLinkCommand
 */
export declare const se_CreateVpcLinkCommand: (input: CreateVpcLinkCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteApiKeyCommand
 */
export declare const se_DeleteApiKeyCommand: (input: DeleteApiKeyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteAuthorizerCommand
 */
export declare const se_DeleteAuthorizerCommand: (input: DeleteAuthorizerCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteBasePathMappingCommand
 */
export declare const se_DeleteBasePathMappingCommand: (input: DeleteBasePathMappingCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteClientCertificateCommand
 */
export declare const se_DeleteClientCertificateCommand: (input: DeleteClientCertificateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteDeploymentCommand
 */
export declare const se_DeleteDeploymentCommand: (input: DeleteDeploymentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteDocumentationPartCommand
 */
export declare const se_DeleteDocumentationPartCommand: (input: DeleteDocumentationPartCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteDocumentationVersionCommand
 */
export declare const se_DeleteDocumentationVersionCommand: (input: DeleteDocumentationVersionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteDomainNameCommand
 */
export declare const se_DeleteDomainNameCommand: (input: DeleteDomainNameCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteDomainNameAccessAssociationCommand
 */
export declare const se_DeleteDomainNameAccessAssociationCommand: (input: DeleteDomainNameAccessAssociationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteGatewayResponseCommand
 */
export declare const se_DeleteGatewayResponseCommand: (input: DeleteGatewayResponseCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteIntegrationCommand
 */
export declare const se_DeleteIntegrationCommand: (input: DeleteIntegrationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteIntegrationResponseCommand
 */
export declare const se_DeleteIntegrationResponseCommand: (input: DeleteIntegrationResponseCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteMethodCommand
 */
export declare const se_DeleteMethodCommand: (input: DeleteMethodCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteMethodResponseCommand
 */
export declare const se_DeleteMethodResponseCommand: (input: DeleteMethodResponseCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteModelCommand
 */
export declare const se_DeleteModelCommand: (input: DeleteModelCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteRequestValidatorCommand
 */
export declare const se_DeleteRequestValidatorCommand: (input: DeleteRequestValidatorCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteResourceCommand
 */
export declare const se_DeleteResourceCommand: (input: DeleteResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteRestApiCommand
 */
export declare const se_DeleteRestApiCommand: (input: DeleteRestApiCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteStageCommand
 */
export declare const se_DeleteStageCommand: (input: DeleteStageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteUsagePlanCommand
 */
export declare const se_DeleteUsagePlanCommand: (input: DeleteUsagePlanCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteUsagePlanKeyCommand
 */
export declare const se_DeleteUsagePlanKeyCommand: (input: DeleteUsagePlanKeyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1DeleteVpcLinkCommand
 */
export declare const se_DeleteVpcLinkCommand: (input: DeleteVpcLinkCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1FlushStageAuthorizersCacheCommand
 */
export declare const se_FlushStageAuthorizersCacheCommand: (input: FlushStageAuthorizersCacheCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1FlushStageCacheCommand
 */
export declare const se_FlushStageCacheCommand: (input: FlushStageCacheCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GenerateClientCertificateCommand
 */
export declare const se_GenerateClientCertificateCommand: (input: GenerateClientCertificateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetAccountCommand
 */
export declare const se_GetAccountCommand: (input: GetAccountCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetApiKeyCommand
 */
export declare const se_GetApiKeyCommand: (input: GetApiKeyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetApiKeysCommand
 */
export declare const se_GetApiKeysCommand: (input: GetApiKeysCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetAuthorizerCommand
 */
export declare const se_GetAuthorizerCommand: (input: GetAuthorizerCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetAuthorizersCommand
 */
export declare const se_GetAuthorizersCommand: (input: GetAuthorizersCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetBasePathMappingCommand
 */
export declare const se_GetBasePathMappingCommand: (input: GetBasePathMappingCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetBasePathMappingsCommand
 */
export declare const se_GetBasePathMappingsCommand: (input: GetBasePathMappingsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetClientCertificateCommand
 */
export declare const se_GetClientCertificateCommand: (input: GetClientCertificateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetClientCertificatesCommand
 */
export declare const se_GetClientCertificatesCommand: (input: GetClientCertificatesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetDeploymentCommand
 */
export declare const se_GetDeploymentCommand: (input: GetDeploymentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetDeploymentsCommand
 */
export declare const se_GetDeploymentsCommand: (input: GetDeploymentsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetDocumentationPartCommand
 */
export declare const se_GetDocumentationPartCommand: (input: GetDocumentationPartCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetDocumentationPartsCommand
 */
export declare const se_GetDocumentationPartsCommand: (input: GetDocumentationPartsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetDocumentationVersionCommand
 */
export declare const se_GetDocumentationVersionCommand: (input: GetDocumentationVersionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetDocumentationVersionsCommand
 */
export declare const se_GetDocumentationVersionsCommand: (input: GetDocumentationVersionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetDomainNameCommand
 */
export declare const se_GetDomainNameCommand: (input: GetDomainNameCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetDomainNameAccessAssociationsCommand
 */
export declare const se_GetDomainNameAccessAssociationsCommand: (input: GetDomainNameAccessAssociationsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetDomainNamesCommand
 */
export declare const se_GetDomainNamesCommand: (input: GetDomainNamesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetExportCommand
 */
export declare const se_GetExportCommand: (input: GetExportCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetGatewayResponseCommand
 */
export declare const se_GetGatewayResponseCommand: (input: GetGatewayResponseCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetGatewayResponsesCommand
 */
export declare const se_GetGatewayResponsesCommand: (input: GetGatewayResponsesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetIntegrationCommand
 */
export declare const se_GetIntegrationCommand: (input: GetIntegrationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetIntegrationResponseCommand
 */
export declare const se_GetIntegrationResponseCommand: (input: GetIntegrationResponseCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetMethodCommand
 */
export declare const se_GetMethodCommand: (input: GetMethodCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetMethodResponseCommand
 */
export declare const se_GetMethodResponseCommand: (input: GetMethodResponseCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetModelCommand
 */
export declare const se_GetModelCommand: (input: GetModelCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetModelsCommand
 */
export declare const se_GetModelsCommand: (input: GetModelsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetModelTemplateCommand
 */
export declare const se_GetModelTemplateCommand: (input: GetModelTemplateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetRequestValidatorCommand
 */
export declare const se_GetRequestValidatorCommand: (input: GetRequestValidatorCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetRequestValidatorsCommand
 */
export declare const se_GetRequestValidatorsCommand: (input: GetRequestValidatorsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetResourceCommand
 */
export declare const se_GetResourceCommand: (input: GetResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetResourcesCommand
 */
export declare const se_GetResourcesCommand: (input: GetResourcesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetRestApiCommand
 */
export declare const se_GetRestApiCommand: (input: GetRestApiCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetRestApisCommand
 */
export declare const se_GetRestApisCommand: (input: GetRestApisCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetSdkCommand
 */
export declare const se_GetSdkCommand: (input: GetSdkCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetSdkTypeCommand
 */
export declare const se_GetSdkTypeCommand: (input: GetSdkTypeCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetSdkTypesCommand
 */
export declare const se_GetSdkTypesCommand: (input: GetSdkTypesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetStageCommand
 */
export declare const se_GetStageCommand: (input: GetStageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetStagesCommand
 */
export declare const se_GetStagesCommand: (input: GetStagesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetTagsCommand
 */
export declare const se_GetTagsCommand: (input: GetTagsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetUsageCommand
 */
export declare const se_GetUsageCommand: (input: GetUsageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetUsagePlanCommand
 */
export declare const se_GetUsagePlanCommand: (input: GetUsagePlanCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetUsagePlanKeyCommand
 */
export declare const se_GetUsagePlanKeyCommand: (input: GetUsagePlanKeyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetUsagePlanKeysCommand
 */
export declare const se_GetUsagePlanKeysCommand: (input: GetUsagePlanKeysCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetUsagePlansCommand
 */
export declare const se_GetUsagePlansCommand: (input: GetUsagePlansCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetVpcLinkCommand
 */
export declare const se_GetVpcLinkCommand: (input: GetVpcLinkCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1GetVpcLinksCommand
 */
export declare const se_GetVpcLinksCommand: (input: GetVpcLinksCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ImportApiKeysCommand
 */
export declare const se_ImportApiKeysCommand: (input: ImportApiKeysCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ImportDocumentationPartsCommand
 */
export declare const se_ImportDocumentationPartsCommand: (input: ImportDocumentationPartsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1ImportRestApiCommand
 */
export declare const se_ImportRestApiCommand: (input: ImportRestApiCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1PutGatewayResponseCommand
 */
export declare const se_PutGatewayResponseCommand: (input: PutGatewayResponseCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1PutIntegrationCommand
 */
export declare const se_PutIntegrationCommand: (input: PutIntegrationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1PutIntegrationResponseCommand
 */
export declare const se_PutIntegrationResponseCommand: (input: PutIntegrationResponseCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1PutMethodCommand
 */
export declare const se_PutMethodCommand: (input: PutMethodCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1PutMethodResponseCommand
 */
export declare const se_PutMethodResponseCommand: (input: PutMethodResponseCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1PutRestApiCommand
 */
export declare const se_PutRestApiCommand: (input: PutRestApiCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1RejectDomainNameAccessAssociationCommand
 */
export declare const se_RejectDomainNameAccessAssociationCommand: (input: RejectDomainNameAccessAssociationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1TagResourceCommand
 */
export declare const se_TagResourceCommand: (input: TagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1TestInvokeAuthorizerCommand
 */
export declare const se_TestInvokeAuthorizerCommand: (input: TestInvokeAuthorizerCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1TestInvokeMethodCommand
 */
export declare const se_TestInvokeMethodCommand: (input: TestInvokeMethodCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UntagResourceCommand
 */
export declare const se_UntagResourceCommand: (input: UntagResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateAccountCommand
 */
export declare const se_UpdateAccountCommand: (input: UpdateAccountCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateApiKeyCommand
 */
export declare const se_UpdateApiKeyCommand: (input: UpdateApiKeyCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateAuthorizerCommand
 */
export declare const se_UpdateAuthorizerCommand: (input: UpdateAuthorizerCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateBasePathMappingCommand
 */
export declare const se_UpdateBasePathMappingCommand: (input: UpdateBasePathMappingCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateClientCertificateCommand
 */
export declare const se_UpdateClientCertificateCommand: (input: UpdateClientCertificateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateDeploymentCommand
 */
export declare const se_UpdateDeploymentCommand: (input: UpdateDeploymentCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateDocumentationPartCommand
 */
export declare const se_UpdateDocumentationPartCommand: (input: UpdateDocumentationPartCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateDocumentationVersionCommand
 */
export declare const se_UpdateDocumentationVersionCommand: (input: UpdateDocumentationVersionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateDomainNameCommand
 */
export declare const se_UpdateDomainNameCommand: (input: UpdateDomainNameCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateGatewayResponseCommand
 */
export declare const se_UpdateGatewayResponseCommand: (input: UpdateGatewayResponseCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateIntegrationCommand
 */
export declare const se_UpdateIntegrationCommand: (input: UpdateIntegrationCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateIntegrationResponseCommand
 */
export declare const se_UpdateIntegrationResponseCommand: (input: UpdateIntegrationResponseCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateMethodCommand
 */
export declare const se_UpdateMethodCommand: (input: UpdateMethodCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateMethodResponseCommand
 */
export declare const se_UpdateMethodResponseCommand: (input: UpdateMethodResponseCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateModelCommand
 */
export declare const se_UpdateModelCommand: (input: UpdateModelCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateRequestValidatorCommand
 */
export declare const se_UpdateRequestValidatorCommand: (input: UpdateRequestValidatorCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateResourceCommand
 */
export declare const se_UpdateResourceCommand: (input: UpdateResourceCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateRestApiCommand
 */
export declare const se_UpdateRestApiCommand: (input: UpdateRestApiCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateStageCommand
 */
export declare const se_UpdateStageCommand: (input: UpdateStageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateUsageCommand
 */
export declare const se_UpdateUsageCommand: (input: UpdateUsageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateUsagePlanCommand
 */
export declare const se_UpdateUsagePlanCommand: (input: UpdateUsagePlanCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * serializeAws_restJson1UpdateVpcLinkCommand
 */
export declare const se_UpdateVpcLinkCommand: (input: UpdateVpcLinkCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
/**
 * deserializeAws_restJson1CreateApiKeyCommand
 */
export declare const de_CreateApiKeyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateApiKeyCommandOutput>;
/**
 * deserializeAws_restJson1CreateAuthorizerCommand
 */
export declare const de_CreateAuthorizerCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateAuthorizerCommandOutput>;
/**
 * deserializeAws_restJson1CreateBasePathMappingCommand
 */
export declare const de_CreateBasePathMappingCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateBasePathMappingCommandOutput>;
/**
 * deserializeAws_restJson1CreateDeploymentCommand
 */
export declare const de_CreateDeploymentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateDeploymentCommandOutput>;
/**
 * deserializeAws_restJson1CreateDocumentationPartCommand
 */
export declare const de_CreateDocumentationPartCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateDocumentationPartCommandOutput>;
/**
 * deserializeAws_restJson1CreateDocumentationVersionCommand
 */
export declare const de_CreateDocumentationVersionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateDocumentationVersionCommandOutput>;
/**
 * deserializeAws_restJson1CreateDomainNameCommand
 */
export declare const de_CreateDomainNameCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateDomainNameCommandOutput>;
/**
 * deserializeAws_restJson1CreateDomainNameAccessAssociationCommand
 */
export declare const de_CreateDomainNameAccessAssociationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateDomainNameAccessAssociationCommandOutput>;
/**
 * deserializeAws_restJson1CreateModelCommand
 */
export declare const de_CreateModelCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateModelCommandOutput>;
/**
 * deserializeAws_restJson1CreateRequestValidatorCommand
 */
export declare const de_CreateRequestValidatorCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateRequestValidatorCommandOutput>;
/**
 * deserializeAws_restJson1CreateResourceCommand
 */
export declare const de_CreateResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateResourceCommandOutput>;
/**
 * deserializeAws_restJson1CreateRestApiCommand
 */
export declare const de_CreateRestApiCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateRestApiCommandOutput>;
/**
 * deserializeAws_restJson1CreateStageCommand
 */
export declare const de_CreateStageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateStageCommandOutput>;
/**
 * deserializeAws_restJson1CreateUsagePlanCommand
 */
export declare const de_CreateUsagePlanCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateUsagePlanCommandOutput>;
/**
 * deserializeAws_restJson1CreateUsagePlanKeyCommand
 */
export declare const de_CreateUsagePlanKeyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateUsagePlanKeyCommandOutput>;
/**
 * deserializeAws_restJson1CreateVpcLinkCommand
 */
export declare const de_CreateVpcLinkCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateVpcLinkCommandOutput>;
/**
 * deserializeAws_restJson1DeleteApiKeyCommand
 */
export declare const de_DeleteApiKeyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteApiKeyCommandOutput>;
/**
 * deserializeAws_restJson1DeleteAuthorizerCommand
 */
export declare const de_DeleteAuthorizerCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteAuthorizerCommandOutput>;
/**
 * deserializeAws_restJson1DeleteBasePathMappingCommand
 */
export declare const de_DeleteBasePathMappingCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteBasePathMappingCommandOutput>;
/**
 * deserializeAws_restJson1DeleteClientCertificateCommand
 */
export declare const de_DeleteClientCertificateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteClientCertificateCommandOutput>;
/**
 * deserializeAws_restJson1DeleteDeploymentCommand
 */
export declare const de_DeleteDeploymentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteDeploymentCommandOutput>;
/**
 * deserializeAws_restJson1DeleteDocumentationPartCommand
 */
export declare const de_DeleteDocumentationPartCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteDocumentationPartCommandOutput>;
/**
 * deserializeAws_restJson1DeleteDocumentationVersionCommand
 */
export declare const de_DeleteDocumentationVersionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteDocumentationVersionCommandOutput>;
/**
 * deserializeAws_restJson1DeleteDomainNameCommand
 */
export declare const de_DeleteDomainNameCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteDomainNameCommandOutput>;
/**
 * deserializeAws_restJson1DeleteDomainNameAccessAssociationCommand
 */
export declare const de_DeleteDomainNameAccessAssociationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteDomainNameAccessAssociationCommandOutput>;
/**
 * deserializeAws_restJson1DeleteGatewayResponseCommand
 */
export declare const de_DeleteGatewayResponseCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteGatewayResponseCommandOutput>;
/**
 * deserializeAws_restJson1DeleteIntegrationCommand
 */
export declare const de_DeleteIntegrationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteIntegrationCommandOutput>;
/**
 * deserializeAws_restJson1DeleteIntegrationResponseCommand
 */
export declare const de_DeleteIntegrationResponseCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteIntegrationResponseCommandOutput>;
/**
 * deserializeAws_restJson1DeleteMethodCommand
 */
export declare const de_DeleteMethodCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteMethodCommandOutput>;
/**
 * deserializeAws_restJson1DeleteMethodResponseCommand
 */
export declare const de_DeleteMethodResponseCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteMethodResponseCommandOutput>;
/**
 * deserializeAws_restJson1DeleteModelCommand
 */
export declare const de_DeleteModelCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteModelCommandOutput>;
/**
 * deserializeAws_restJson1DeleteRequestValidatorCommand
 */
export declare const de_DeleteRequestValidatorCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteRequestValidatorCommandOutput>;
/**
 * deserializeAws_restJson1DeleteResourceCommand
 */
export declare const de_DeleteResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteResourceCommandOutput>;
/**
 * deserializeAws_restJson1DeleteRestApiCommand
 */
export declare const de_DeleteRestApiCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteRestApiCommandOutput>;
/**
 * deserializeAws_restJson1DeleteStageCommand
 */
export declare const de_DeleteStageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteStageCommandOutput>;
/**
 * deserializeAws_restJson1DeleteUsagePlanCommand
 */
export declare const de_DeleteUsagePlanCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteUsagePlanCommandOutput>;
/**
 * deserializeAws_restJson1DeleteUsagePlanKeyCommand
 */
export declare const de_DeleteUsagePlanKeyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteUsagePlanKeyCommandOutput>;
/**
 * deserializeAws_restJson1DeleteVpcLinkCommand
 */
export declare const de_DeleteVpcLinkCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteVpcLinkCommandOutput>;
/**
 * deserializeAws_restJson1FlushStageAuthorizersCacheCommand
 */
export declare const de_FlushStageAuthorizersCacheCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<FlushStageAuthorizersCacheCommandOutput>;
/**
 * deserializeAws_restJson1FlushStageCacheCommand
 */
export declare const de_FlushStageCacheCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<FlushStageCacheCommandOutput>;
/**
 * deserializeAws_restJson1GenerateClientCertificateCommand
 */
export declare const de_GenerateClientCertificateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GenerateClientCertificateCommandOutput>;
/**
 * deserializeAws_restJson1GetAccountCommand
 */
export declare const de_GetAccountCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetAccountCommandOutput>;
/**
 * deserializeAws_restJson1GetApiKeyCommand
 */
export declare const de_GetApiKeyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetApiKeyCommandOutput>;
/**
 * deserializeAws_restJson1GetApiKeysCommand
 */
export declare const de_GetApiKeysCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetApiKeysCommandOutput>;
/**
 * deserializeAws_restJson1GetAuthorizerCommand
 */
export declare const de_GetAuthorizerCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetAuthorizerCommandOutput>;
/**
 * deserializeAws_restJson1GetAuthorizersCommand
 */
export declare const de_GetAuthorizersCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetAuthorizersCommandOutput>;
/**
 * deserializeAws_restJson1GetBasePathMappingCommand
 */
export declare const de_GetBasePathMappingCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetBasePathMappingCommandOutput>;
/**
 * deserializeAws_restJson1GetBasePathMappingsCommand
 */
export declare const de_GetBasePathMappingsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetBasePathMappingsCommandOutput>;
/**
 * deserializeAws_restJson1GetClientCertificateCommand
 */
export declare const de_GetClientCertificateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetClientCertificateCommandOutput>;
/**
 * deserializeAws_restJson1GetClientCertificatesCommand
 */
export declare const de_GetClientCertificatesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetClientCertificatesCommandOutput>;
/**
 * deserializeAws_restJson1GetDeploymentCommand
 */
export declare const de_GetDeploymentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDeploymentCommandOutput>;
/**
 * deserializeAws_restJson1GetDeploymentsCommand
 */
export declare const de_GetDeploymentsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDeploymentsCommandOutput>;
/**
 * deserializeAws_restJson1GetDocumentationPartCommand
 */
export declare const de_GetDocumentationPartCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDocumentationPartCommandOutput>;
/**
 * deserializeAws_restJson1GetDocumentationPartsCommand
 */
export declare const de_GetDocumentationPartsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDocumentationPartsCommandOutput>;
/**
 * deserializeAws_restJson1GetDocumentationVersionCommand
 */
export declare const de_GetDocumentationVersionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDocumentationVersionCommandOutput>;
/**
 * deserializeAws_restJson1GetDocumentationVersionsCommand
 */
export declare const de_GetDocumentationVersionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDocumentationVersionsCommandOutput>;
/**
 * deserializeAws_restJson1GetDomainNameCommand
 */
export declare const de_GetDomainNameCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDomainNameCommandOutput>;
/**
 * deserializeAws_restJson1GetDomainNameAccessAssociationsCommand
 */
export declare const de_GetDomainNameAccessAssociationsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDomainNameAccessAssociationsCommandOutput>;
/**
 * deserializeAws_restJson1GetDomainNamesCommand
 */
export declare const de_GetDomainNamesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetDomainNamesCommandOutput>;
/**
 * deserializeAws_restJson1GetExportCommand
 */
export declare const de_GetExportCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetExportCommandOutput>;
/**
 * deserializeAws_restJson1GetGatewayResponseCommand
 */
export declare const de_GetGatewayResponseCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetGatewayResponseCommandOutput>;
/**
 * deserializeAws_restJson1GetGatewayResponsesCommand
 */
export declare const de_GetGatewayResponsesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetGatewayResponsesCommandOutput>;
/**
 * deserializeAws_restJson1GetIntegrationCommand
 */
export declare const de_GetIntegrationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetIntegrationCommandOutput>;
/**
 * deserializeAws_restJson1GetIntegrationResponseCommand
 */
export declare const de_GetIntegrationResponseCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetIntegrationResponseCommandOutput>;
/**
 * deserializeAws_restJson1GetMethodCommand
 */
export declare const de_GetMethodCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetMethodCommandOutput>;
/**
 * deserializeAws_restJson1GetMethodResponseCommand
 */
export declare const de_GetMethodResponseCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetMethodResponseCommandOutput>;
/**
 * deserializeAws_restJson1GetModelCommand
 */
export declare const de_GetModelCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetModelCommandOutput>;
/**
 * deserializeAws_restJson1GetModelsCommand
 */
export declare const de_GetModelsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetModelsCommandOutput>;
/**
 * deserializeAws_restJson1GetModelTemplateCommand
 */
export declare const de_GetModelTemplateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetModelTemplateCommandOutput>;
/**
 * deserializeAws_restJson1GetRequestValidatorCommand
 */
export declare const de_GetRequestValidatorCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetRequestValidatorCommandOutput>;
/**
 * deserializeAws_restJson1GetRequestValidatorsCommand
 */
export declare const de_GetRequestValidatorsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetRequestValidatorsCommandOutput>;
/**
 * deserializeAws_restJson1GetResourceCommand
 */
export declare const de_GetResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetResourceCommandOutput>;
/**
 * deserializeAws_restJson1GetResourcesCommand
 */
export declare const de_GetResourcesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetResourcesCommandOutput>;
/**
 * deserializeAws_restJson1GetRestApiCommand
 */
export declare const de_GetRestApiCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetRestApiCommandOutput>;
/**
 * deserializeAws_restJson1GetRestApisCommand
 */
export declare const de_GetRestApisCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetRestApisCommandOutput>;
/**
 * deserializeAws_restJson1GetSdkCommand
 */
export declare const de_GetSdkCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetSdkCommandOutput>;
/**
 * deserializeAws_restJson1GetSdkTypeCommand
 */
export declare const de_GetSdkTypeCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetSdkTypeCommandOutput>;
/**
 * deserializeAws_restJson1GetSdkTypesCommand
 */
export declare const de_GetSdkTypesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetSdkTypesCommandOutput>;
/**
 * deserializeAws_restJson1GetStageCommand
 */
export declare const de_GetStageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetStageCommandOutput>;
/**
 * deserializeAws_restJson1GetStagesCommand
 */
export declare const de_GetStagesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetStagesCommandOutput>;
/**
 * deserializeAws_restJson1GetTagsCommand
 */
export declare const de_GetTagsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetTagsCommandOutput>;
/**
 * deserializeAws_restJson1GetUsageCommand
 */
export declare const de_GetUsageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetUsageCommandOutput>;
/**
 * deserializeAws_restJson1GetUsagePlanCommand
 */
export declare const de_GetUsagePlanCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetUsagePlanCommandOutput>;
/**
 * deserializeAws_restJson1GetUsagePlanKeyCommand
 */
export declare const de_GetUsagePlanKeyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetUsagePlanKeyCommandOutput>;
/**
 * deserializeAws_restJson1GetUsagePlanKeysCommand
 */
export declare const de_GetUsagePlanKeysCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetUsagePlanKeysCommandOutput>;
/**
 * deserializeAws_restJson1GetUsagePlansCommand
 */
export declare const de_GetUsagePlansCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetUsagePlansCommandOutput>;
/**
 * deserializeAws_restJson1GetVpcLinkCommand
 */
export declare const de_GetVpcLinkCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetVpcLinkCommandOutput>;
/**
 * deserializeAws_restJson1GetVpcLinksCommand
 */
export declare const de_GetVpcLinksCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetVpcLinksCommandOutput>;
/**
 * deserializeAws_restJson1ImportApiKeysCommand
 */
export declare const de_ImportApiKeysCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ImportApiKeysCommandOutput>;
/**
 * deserializeAws_restJson1ImportDocumentationPartsCommand
 */
export declare const de_ImportDocumentationPartsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ImportDocumentationPartsCommandOutput>;
/**
 * deserializeAws_restJson1ImportRestApiCommand
 */
export declare const de_ImportRestApiCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ImportRestApiCommandOutput>;
/**
 * deserializeAws_restJson1PutGatewayResponseCommand
 */
export declare const de_PutGatewayResponseCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutGatewayResponseCommandOutput>;
/**
 * deserializeAws_restJson1PutIntegrationCommand
 */
export declare const de_PutIntegrationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutIntegrationCommandOutput>;
/**
 * deserializeAws_restJson1PutIntegrationResponseCommand
 */
export declare const de_PutIntegrationResponseCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutIntegrationResponseCommandOutput>;
/**
 * deserializeAws_restJson1PutMethodCommand
 */
export declare const de_PutMethodCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutMethodCommandOutput>;
/**
 * deserializeAws_restJson1PutMethodResponseCommand
 */
export declare const de_PutMethodResponseCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutMethodResponseCommandOutput>;
/**
 * deserializeAws_restJson1PutRestApiCommand
 */
export declare const de_PutRestApiCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PutRestApiCommandOutput>;
/**
 * deserializeAws_restJson1RejectDomainNameAccessAssociationCommand
 */
export declare const de_RejectDomainNameAccessAssociationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RejectDomainNameAccessAssociationCommandOutput>;
/**
 * deserializeAws_restJson1TagResourceCommand
 */
export declare const de_TagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TagResourceCommandOutput>;
/**
 * deserializeAws_restJson1TestInvokeAuthorizerCommand
 */
export declare const de_TestInvokeAuthorizerCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TestInvokeAuthorizerCommandOutput>;
/**
 * deserializeAws_restJson1TestInvokeMethodCommand
 */
export declare const de_TestInvokeMethodCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<TestInvokeMethodCommandOutput>;
/**
 * deserializeAws_restJson1UntagResourceCommand
 */
export declare const de_UntagResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UntagResourceCommandOutput>;
/**
 * deserializeAws_restJson1UpdateAccountCommand
 */
export declare const de_UpdateAccountCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateAccountCommandOutput>;
/**
 * deserializeAws_restJson1UpdateApiKeyCommand
 */
export declare const de_UpdateApiKeyCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateApiKeyCommandOutput>;
/**
 * deserializeAws_restJson1UpdateAuthorizerCommand
 */
export declare const de_UpdateAuthorizerCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateAuthorizerCommandOutput>;
/**
 * deserializeAws_restJson1UpdateBasePathMappingCommand
 */
export declare const de_UpdateBasePathMappingCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateBasePathMappingCommandOutput>;
/**
 * deserializeAws_restJson1UpdateClientCertificateCommand
 */
export declare const de_UpdateClientCertificateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateClientCertificateCommandOutput>;
/**
 * deserializeAws_restJson1UpdateDeploymentCommand
 */
export declare const de_UpdateDeploymentCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateDeploymentCommandOutput>;
/**
 * deserializeAws_restJson1UpdateDocumentationPartCommand
 */
export declare const de_UpdateDocumentationPartCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateDocumentationPartCommandOutput>;
/**
 * deserializeAws_restJson1UpdateDocumentationVersionCommand
 */
export declare const de_UpdateDocumentationVersionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateDocumentationVersionCommandOutput>;
/**
 * deserializeAws_restJson1UpdateDomainNameCommand
 */
export declare const de_UpdateDomainNameCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateDomainNameCommandOutput>;
/**
 * deserializeAws_restJson1UpdateGatewayResponseCommand
 */
export declare const de_UpdateGatewayResponseCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateGatewayResponseCommandOutput>;
/**
 * deserializeAws_restJson1UpdateIntegrationCommand
 */
export declare const de_UpdateIntegrationCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateIntegrationCommandOutput>;
/**
 * deserializeAws_restJson1UpdateIntegrationResponseCommand
 */
export declare const de_UpdateIntegrationResponseCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateIntegrationResponseCommandOutput>;
/**
 * deserializeAws_restJson1UpdateMethodCommand
 */
export declare const de_UpdateMethodCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateMethodCommandOutput>;
/**
 * deserializeAws_restJson1UpdateMethodResponseCommand
 */
export declare const de_UpdateMethodResponseCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateMethodResponseCommandOutput>;
/**
 * deserializeAws_restJson1UpdateModelCommand
 */
export declare const de_UpdateModelCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateModelCommandOutput>;
/**
 * deserializeAws_restJson1UpdateRequestValidatorCommand
 */
export declare const de_UpdateRequestValidatorCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateRequestValidatorCommandOutput>;
/**
 * deserializeAws_restJson1UpdateResourceCommand
 */
export declare const de_UpdateResourceCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateResourceCommandOutput>;
/**
 * deserializeAws_restJson1UpdateRestApiCommand
 */
export declare const de_UpdateRestApiCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateRestApiCommandOutput>;
/**
 * deserializeAws_restJson1UpdateStageCommand
 */
export declare const de_UpdateStageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateStageCommandOutput>;
/**
 * deserializeAws_restJson1UpdateUsageCommand
 */
export declare const de_UpdateUsageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateUsageCommandOutput>;
/**
 * deserializeAws_restJson1UpdateUsagePlanCommand
 */
export declare const de_UpdateUsagePlanCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateUsagePlanCommandOutput>;
/**
 * deserializeAws_restJson1UpdateVpcLinkCommand
 */
export declare const de_UpdateVpcLinkCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateVpcLinkCommandOutput>;
