import {
  HostHeaderInputConfig,
  HostHeaderResolvedConfig,
} from "@aws-sdk/middleware-host-header";
import {
  UserAgentInputConfig,
  UserAgentResolvedConfig,
} from "@aws-sdk/middleware-user-agent";
import {
  RegionInputConfig,
  RegionResolvedConfig,
} from "@smithy/config-resolver";
import {
  EndpointInputConfig,
  EndpointResolvedConfig,
} from "@smithy/middleware-endpoint";
import {
  RetryInputConfig,
  RetryResolvedConfig,
} from "@smithy/middleware-retry";
import { HttpHandlerUserInput as __HttpHandlerUserInput } from "@smithy/protocol-http";
import {
  Client as __Client,
  DefaultsMode as __DefaultsMode,
  SmithyConfiguration as __SmithyConfiguration,
  SmithyResolvedConfiguration as __SmithyResolvedConfiguration,
} from "@smithy/smithy-client";
import {
  AwsCredentialIdentityProvider,
  BodyLengthCalculator as __BodyLengthCalculator,
  CheckOptionalClientConfig as __CheckOptionalClientConfig,
  ChecksumConstructor as __ChecksumConstructor,
  Decoder as __Decoder,
  Encoder as __Encoder,
  HashConstructor as __HashConstructor,
  HttpHandlerOptions as __HttpHandlerOptions,
  Logger as __Logger,
  Provider as __Provider,
  Provider,
  StreamCollector as __StreamCollector,
  UrlParser as __UrlParser,
  UserAgent as __UserAgent,
} from "@smithy/types";
import {
  HttpAuthSchemeInputConfig,
  HttpAuthSchemeResolvedConfig,
} from "./auth/httpAuthSchemeProvider";
import {
  CreateApiKeyCommandInput,
  CreateApiKeyCommandOutput,
} from "./commands/CreateApiKeyCommand";
import {
  CreateAuthorizerCommandInput,
  CreateAuthorizerCommandOutput,
} from "./commands/CreateAuthorizerCommand";
import {
  CreateBasePathMappingCommandInput,
  CreateBasePathMappingCommandOutput,
} from "./commands/CreateBasePathMappingCommand";
import {
  CreateDeploymentCommandInput,
  CreateDeploymentCommandOutput,
} from "./commands/CreateDeploymentCommand";
import {
  CreateDocumentationPartCommandInput,
  CreateDocumentationPartCommandOutput,
} from "./commands/CreateDocumentationPartCommand";
import {
  CreateDocumentationVersionCommandInput,
  CreateDocumentationVersionCommandOutput,
} from "./commands/CreateDocumentationVersionCommand";
import {
  CreateDomainNameAccessAssociationCommandInput,
  CreateDomainNameAccessAssociationCommandOutput,
} from "./commands/CreateDomainNameAccessAssociationCommand";
import {
  CreateDomainNameCommandInput,
  CreateDomainNameCommandOutput,
} from "./commands/CreateDomainNameCommand";
import {
  CreateModelCommandInput,
  CreateModelCommandOutput,
} from "./commands/CreateModelCommand";
import {
  CreateRequestValidatorCommandInput,
  CreateRequestValidatorCommandOutput,
} from "./commands/CreateRequestValidatorCommand";
import {
  CreateResourceCommandInput,
  CreateResourceCommandOutput,
} from "./commands/CreateResourceCommand";
import {
  CreateRestApiCommandInput,
  CreateRestApiCommandOutput,
} from "./commands/CreateRestApiCommand";
import {
  CreateStageCommandInput,
  CreateStageCommandOutput,
} from "./commands/CreateStageCommand";
import {
  CreateUsagePlanCommandInput,
  CreateUsagePlanCommandOutput,
} from "./commands/CreateUsagePlanCommand";
import {
  CreateUsagePlanKeyCommandInput,
  CreateUsagePlanKeyCommandOutput,
} from "./commands/CreateUsagePlanKeyCommand";
import {
  CreateVpcLinkCommandInput,
  CreateVpcLinkCommandOutput,
} from "./commands/CreateVpcLinkCommand";
import {
  DeleteApiKeyCommandInput,
  DeleteApiKeyCommandOutput,
} from "./commands/DeleteApiKeyCommand";
import {
  DeleteAuthorizerCommandInput,
  DeleteAuthorizerCommandOutput,
} from "./commands/DeleteAuthorizerCommand";
import {
  DeleteBasePathMappingCommandInput,
  DeleteBasePathMappingCommandOutput,
} from "./commands/DeleteBasePathMappingCommand";
import {
  DeleteClientCertificateCommandInput,
  DeleteClientCertificateCommandOutput,
} from "./commands/DeleteClientCertificateCommand";
import {
  DeleteDeploymentCommandInput,
  DeleteDeploymentCommandOutput,
} from "./commands/DeleteDeploymentCommand";
import {
  DeleteDocumentationPartCommandInput,
  DeleteDocumentationPartCommandOutput,
} from "./commands/DeleteDocumentationPartCommand";
import {
  DeleteDocumentationVersionCommandInput,
  DeleteDocumentationVersionCommandOutput,
} from "./commands/DeleteDocumentationVersionCommand";
import {
  DeleteDomainNameAccessAssociationCommandInput,
  DeleteDomainNameAccessAssociationCommandOutput,
} from "./commands/DeleteDomainNameAccessAssociationCommand";
import {
  DeleteDomainNameCommandInput,
  DeleteDomainNameCommandOutput,
} from "./commands/DeleteDomainNameCommand";
import {
  DeleteGatewayResponseCommandInput,
  DeleteGatewayResponseCommandOutput,
} from "./commands/DeleteGatewayResponseCommand";
import {
  DeleteIntegrationCommandInput,
  DeleteIntegrationCommandOutput,
} from "./commands/DeleteIntegrationCommand";
import {
  DeleteIntegrationResponseCommandInput,
  DeleteIntegrationResponseCommandOutput,
} from "./commands/DeleteIntegrationResponseCommand";
import {
  DeleteMethodCommandInput,
  DeleteMethodCommandOutput,
} from "./commands/DeleteMethodCommand";
import {
  DeleteMethodResponseCommandInput,
  DeleteMethodResponseCommandOutput,
} from "./commands/DeleteMethodResponseCommand";
import {
  DeleteModelCommandInput,
  DeleteModelCommandOutput,
} from "./commands/DeleteModelCommand";
import {
  DeleteRequestValidatorCommandInput,
  DeleteRequestValidatorCommandOutput,
} from "./commands/DeleteRequestValidatorCommand";
import {
  DeleteResourceCommandInput,
  DeleteResourceCommandOutput,
} from "./commands/DeleteResourceCommand";
import {
  DeleteRestApiCommandInput,
  DeleteRestApiCommandOutput,
} from "./commands/DeleteRestApiCommand";
import {
  DeleteStageCommandInput,
  DeleteStageCommandOutput,
} from "./commands/DeleteStageCommand";
import {
  DeleteUsagePlanCommandInput,
  DeleteUsagePlanCommandOutput,
} from "./commands/DeleteUsagePlanCommand";
import {
  DeleteUsagePlanKeyCommandInput,
  DeleteUsagePlanKeyCommandOutput,
} from "./commands/DeleteUsagePlanKeyCommand";
import {
  DeleteVpcLinkCommandInput,
  DeleteVpcLinkCommandOutput,
} from "./commands/DeleteVpcLinkCommand";
import {
  FlushStageAuthorizersCacheCommandInput,
  FlushStageAuthorizersCacheCommandOutput,
} from "./commands/FlushStageAuthorizersCacheCommand";
import {
  FlushStageCacheCommandInput,
  FlushStageCacheCommandOutput,
} from "./commands/FlushStageCacheCommand";
import {
  GenerateClientCertificateCommandInput,
  GenerateClientCertificateCommandOutput,
} from "./commands/GenerateClientCertificateCommand";
import {
  GetAccountCommandInput,
  GetAccountCommandOutput,
} from "./commands/GetAccountCommand";
import {
  GetApiKeyCommandInput,
  GetApiKeyCommandOutput,
} from "./commands/GetApiKeyCommand";
import {
  GetApiKeysCommandInput,
  GetApiKeysCommandOutput,
} from "./commands/GetApiKeysCommand";
import {
  GetAuthorizerCommandInput,
  GetAuthorizerCommandOutput,
} from "./commands/GetAuthorizerCommand";
import {
  GetAuthorizersCommandInput,
  GetAuthorizersCommandOutput,
} from "./commands/GetAuthorizersCommand";
import {
  GetBasePathMappingCommandInput,
  GetBasePathMappingCommandOutput,
} from "./commands/GetBasePathMappingCommand";
import {
  GetBasePathMappingsCommandInput,
  GetBasePathMappingsCommandOutput,
} from "./commands/GetBasePathMappingsCommand";
import {
  GetClientCertificateCommandInput,
  GetClientCertificateCommandOutput,
} from "./commands/GetClientCertificateCommand";
import {
  GetClientCertificatesCommandInput,
  GetClientCertificatesCommandOutput,
} from "./commands/GetClientCertificatesCommand";
import {
  GetDeploymentCommandInput,
  GetDeploymentCommandOutput,
} from "./commands/GetDeploymentCommand";
import {
  GetDeploymentsCommandInput,
  GetDeploymentsCommandOutput,
} from "./commands/GetDeploymentsCommand";
import {
  GetDocumentationPartCommandInput,
  GetDocumentationPartCommandOutput,
} from "./commands/GetDocumentationPartCommand";
import {
  GetDocumentationPartsCommandInput,
  GetDocumentationPartsCommandOutput,
} from "./commands/GetDocumentationPartsCommand";
import {
  GetDocumentationVersionCommandInput,
  GetDocumentationVersionCommandOutput,
} from "./commands/GetDocumentationVersionCommand";
import {
  GetDocumentationVersionsCommandInput,
  GetDocumentationVersionsCommandOutput,
} from "./commands/GetDocumentationVersionsCommand";
import {
  GetDomainNameAccessAssociationsCommandInput,
  GetDomainNameAccessAssociationsCommandOutput,
} from "./commands/GetDomainNameAccessAssociationsCommand";
import {
  GetDomainNameCommandInput,
  GetDomainNameCommandOutput,
} from "./commands/GetDomainNameCommand";
import {
  GetDomainNamesCommandInput,
  GetDomainNamesCommandOutput,
} from "./commands/GetDomainNamesCommand";
import {
  GetExportCommandInput,
  GetExportCommandOutput,
} from "./commands/GetExportCommand";
import {
  GetGatewayResponseCommandInput,
  GetGatewayResponseCommandOutput,
} from "./commands/GetGatewayResponseCommand";
import {
  GetGatewayResponsesCommandInput,
  GetGatewayResponsesCommandOutput,
} from "./commands/GetGatewayResponsesCommand";
import {
  GetIntegrationCommandInput,
  GetIntegrationCommandOutput,
} from "./commands/GetIntegrationCommand";
import {
  GetIntegrationResponseCommandInput,
  GetIntegrationResponseCommandOutput,
} from "./commands/GetIntegrationResponseCommand";
import {
  GetMethodCommandInput,
  GetMethodCommandOutput,
} from "./commands/GetMethodCommand";
import {
  GetMethodResponseCommandInput,
  GetMethodResponseCommandOutput,
} from "./commands/GetMethodResponseCommand";
import {
  GetModelCommandInput,
  GetModelCommandOutput,
} from "./commands/GetModelCommand";
import {
  GetModelsCommandInput,
  GetModelsCommandOutput,
} from "./commands/GetModelsCommand";
import {
  GetModelTemplateCommandInput,
  GetModelTemplateCommandOutput,
} from "./commands/GetModelTemplateCommand";
import {
  GetRequestValidatorCommandInput,
  GetRequestValidatorCommandOutput,
} from "./commands/GetRequestValidatorCommand";
import {
  GetRequestValidatorsCommandInput,
  GetRequestValidatorsCommandOutput,
} from "./commands/GetRequestValidatorsCommand";
import {
  GetResourceCommandInput,
  GetResourceCommandOutput,
} from "./commands/GetResourceCommand";
import {
  GetResourcesCommandInput,
  GetResourcesCommandOutput,
} from "./commands/GetResourcesCommand";
import {
  GetRestApiCommandInput,
  GetRestApiCommandOutput,
} from "./commands/GetRestApiCommand";
import {
  GetRestApisCommandInput,
  GetRestApisCommandOutput,
} from "./commands/GetRestApisCommand";
import {
  GetSdkCommandInput,
  GetSdkCommandOutput,
} from "./commands/GetSdkCommand";
import {
  GetSdkTypeCommandInput,
  GetSdkTypeCommandOutput,
} from "./commands/GetSdkTypeCommand";
import {
  GetSdkTypesCommandInput,
  GetSdkTypesCommandOutput,
} from "./commands/GetSdkTypesCommand";
import {
  GetStageCommandInput,
  GetStageCommandOutput,
} from "./commands/GetStageCommand";
import {
  GetStagesCommandInput,
  GetStagesCommandOutput,
} from "./commands/GetStagesCommand";
import {
  GetTagsCommandInput,
  GetTagsCommandOutput,
} from "./commands/GetTagsCommand";
import {
  GetUsageCommandInput,
  GetUsageCommandOutput,
} from "./commands/GetUsageCommand";
import {
  GetUsagePlanCommandInput,
  GetUsagePlanCommandOutput,
} from "./commands/GetUsagePlanCommand";
import {
  GetUsagePlanKeyCommandInput,
  GetUsagePlanKeyCommandOutput,
} from "./commands/GetUsagePlanKeyCommand";
import {
  GetUsagePlanKeysCommandInput,
  GetUsagePlanKeysCommandOutput,
} from "./commands/GetUsagePlanKeysCommand";
import {
  GetUsagePlansCommandInput,
  GetUsagePlansCommandOutput,
} from "./commands/GetUsagePlansCommand";
import {
  GetVpcLinkCommandInput,
  GetVpcLinkCommandOutput,
} from "./commands/GetVpcLinkCommand";
import {
  GetVpcLinksCommandInput,
  GetVpcLinksCommandOutput,
} from "./commands/GetVpcLinksCommand";
import {
  ImportApiKeysCommandInput,
  ImportApiKeysCommandOutput,
} from "./commands/ImportApiKeysCommand";
import {
  ImportDocumentationPartsCommandInput,
  ImportDocumentationPartsCommandOutput,
} from "./commands/ImportDocumentationPartsCommand";
import {
  ImportRestApiCommandInput,
  ImportRestApiCommandOutput,
} from "./commands/ImportRestApiCommand";
import {
  PutGatewayResponseCommandInput,
  PutGatewayResponseCommandOutput,
} from "./commands/PutGatewayResponseCommand";
import {
  PutIntegrationCommandInput,
  PutIntegrationCommandOutput,
} from "./commands/PutIntegrationCommand";
import {
  PutIntegrationResponseCommandInput,
  PutIntegrationResponseCommandOutput,
} from "./commands/PutIntegrationResponseCommand";
import {
  PutMethodCommandInput,
  PutMethodCommandOutput,
} from "./commands/PutMethodCommand";
import {
  PutMethodResponseCommandInput,
  PutMethodResponseCommandOutput,
} from "./commands/PutMethodResponseCommand";
import {
  PutRestApiCommandInput,
  PutRestApiCommandOutput,
} from "./commands/PutRestApiCommand";
import {
  RejectDomainNameAccessAssociationCommandInput,
  RejectDomainNameAccessAssociationCommandOutput,
} from "./commands/RejectDomainNameAccessAssociationCommand";
import {
  TagResourceCommandInput,
  TagResourceCommandOutput,
} from "./commands/TagResourceCommand";
import {
  TestInvokeAuthorizerCommandInput,
  TestInvokeAuthorizerCommandOutput,
} from "./commands/TestInvokeAuthorizerCommand";
import {
  TestInvokeMethodCommandInput,
  TestInvokeMethodCommandOutput,
} from "./commands/TestInvokeMethodCommand";
import {
  UntagResourceCommandInput,
  UntagResourceCommandOutput,
} from "./commands/UntagResourceCommand";
import {
  UpdateAccountCommandInput,
  UpdateAccountCommandOutput,
} from "./commands/UpdateAccountCommand";
import {
  UpdateApiKeyCommandInput,
  UpdateApiKeyCommandOutput,
} from "./commands/UpdateApiKeyCommand";
import {
  UpdateAuthorizerCommandInput,
  UpdateAuthorizerCommandOutput,
} from "./commands/UpdateAuthorizerCommand";
import {
  UpdateBasePathMappingCommandInput,
  UpdateBasePathMappingCommandOutput,
} from "./commands/UpdateBasePathMappingCommand";
import {
  UpdateClientCertificateCommandInput,
  UpdateClientCertificateCommandOutput,
} from "./commands/UpdateClientCertificateCommand";
import {
  UpdateDeploymentCommandInput,
  UpdateDeploymentCommandOutput,
} from "./commands/UpdateDeploymentCommand";
import {
  UpdateDocumentationPartCommandInput,
  UpdateDocumentationPartCommandOutput,
} from "./commands/UpdateDocumentationPartCommand";
import {
  UpdateDocumentationVersionCommandInput,
  UpdateDocumentationVersionCommandOutput,
} from "./commands/UpdateDocumentationVersionCommand";
import {
  UpdateDomainNameCommandInput,
  UpdateDomainNameCommandOutput,
} from "./commands/UpdateDomainNameCommand";
import {
  UpdateGatewayResponseCommandInput,
  UpdateGatewayResponseCommandOutput,
} from "./commands/UpdateGatewayResponseCommand";
import {
  UpdateIntegrationCommandInput,
  UpdateIntegrationCommandOutput,
} from "./commands/UpdateIntegrationCommand";
import {
  UpdateIntegrationResponseCommandInput,
  UpdateIntegrationResponseCommandOutput,
} from "./commands/UpdateIntegrationResponseCommand";
import {
  UpdateMethodCommandInput,
  UpdateMethodCommandOutput,
} from "./commands/UpdateMethodCommand";
import {
  UpdateMethodResponseCommandInput,
  UpdateMethodResponseCommandOutput,
} from "./commands/UpdateMethodResponseCommand";
import {
  UpdateModelCommandInput,
  UpdateModelCommandOutput,
} from "./commands/UpdateModelCommand";
import {
  UpdateRequestValidatorCommandInput,
  UpdateRequestValidatorCommandOutput,
} from "./commands/UpdateRequestValidatorCommand";
import {
  UpdateResourceCommandInput,
  UpdateResourceCommandOutput,
} from "./commands/UpdateResourceCommand";
import {
  UpdateRestApiCommandInput,
  UpdateRestApiCommandOutput,
} from "./commands/UpdateRestApiCommand";
import {
  UpdateStageCommandInput,
  UpdateStageCommandOutput,
} from "./commands/UpdateStageCommand";
import {
  UpdateUsageCommandInput,
  UpdateUsageCommandOutput,
} from "./commands/UpdateUsageCommand";
import {
  UpdateUsagePlanCommandInput,
  UpdateUsagePlanCommandOutput,
} from "./commands/UpdateUsagePlanCommand";
import {
  UpdateVpcLinkCommandInput,
  UpdateVpcLinkCommandOutput,
} from "./commands/UpdateVpcLinkCommand";
import {
  ClientInputEndpointParameters,
  ClientResolvedEndpointParameters,
  EndpointParameters,
} from "./endpoint/EndpointParameters";
import { RuntimeExtension, RuntimeExtensionsConfig } from "./runtimeExtensions";
export { __Client };
export type ServiceInputTypes =
  | CreateApiKeyCommandInput
  | CreateAuthorizerCommandInput
  | CreateBasePathMappingCommandInput
  | CreateDeploymentCommandInput
  | CreateDocumentationPartCommandInput
  | CreateDocumentationVersionCommandInput
  | CreateDomainNameAccessAssociationCommandInput
  | CreateDomainNameCommandInput
  | CreateModelCommandInput
  | CreateRequestValidatorCommandInput
  | CreateResourceCommandInput
  | CreateRestApiCommandInput
  | CreateStageCommandInput
  | CreateUsagePlanCommandInput
  | CreateUsagePlanKeyCommandInput
  | CreateVpcLinkCommandInput
  | DeleteApiKeyCommandInput
  | DeleteAuthorizerCommandInput
  | DeleteBasePathMappingCommandInput
  | DeleteClientCertificateCommandInput
  | DeleteDeploymentCommandInput
  | DeleteDocumentationPartCommandInput
  | DeleteDocumentationVersionCommandInput
  | DeleteDomainNameAccessAssociationCommandInput
  | DeleteDomainNameCommandInput
  | DeleteGatewayResponseCommandInput
  | DeleteIntegrationCommandInput
  | DeleteIntegrationResponseCommandInput
  | DeleteMethodCommandInput
  | DeleteMethodResponseCommandInput
  | DeleteModelCommandInput
  | DeleteRequestValidatorCommandInput
  | DeleteResourceCommandInput
  | DeleteRestApiCommandInput
  | DeleteStageCommandInput
  | DeleteUsagePlanCommandInput
  | DeleteUsagePlanKeyCommandInput
  | DeleteVpcLinkCommandInput
  | FlushStageAuthorizersCacheCommandInput
  | FlushStageCacheCommandInput
  | GenerateClientCertificateCommandInput
  | GetAccountCommandInput
  | GetApiKeyCommandInput
  | GetApiKeysCommandInput
  | GetAuthorizerCommandInput
  | GetAuthorizersCommandInput
  | GetBasePathMappingCommandInput
  | GetBasePathMappingsCommandInput
  | GetClientCertificateCommandInput
  | GetClientCertificatesCommandInput
  | GetDeploymentCommandInput
  | GetDeploymentsCommandInput
  | GetDocumentationPartCommandInput
  | GetDocumentationPartsCommandInput
  | GetDocumentationVersionCommandInput
  | GetDocumentationVersionsCommandInput
  | GetDomainNameAccessAssociationsCommandInput
  | GetDomainNameCommandInput
  | GetDomainNamesCommandInput
  | GetExportCommandInput
  | GetGatewayResponseCommandInput
  | GetGatewayResponsesCommandInput
  | GetIntegrationCommandInput
  | GetIntegrationResponseCommandInput
  | GetMethodCommandInput
  | GetMethodResponseCommandInput
  | GetModelCommandInput
  | GetModelTemplateCommandInput
  | GetModelsCommandInput
  | GetRequestValidatorCommandInput
  | GetRequestValidatorsCommandInput
  | GetResourceCommandInput
  | GetResourcesCommandInput
  | GetRestApiCommandInput
  | GetRestApisCommandInput
  | GetSdkCommandInput
  | GetSdkTypeCommandInput
  | GetSdkTypesCommandInput
  | GetStageCommandInput
  | GetStagesCommandInput
  | GetTagsCommandInput
  | GetUsageCommandInput
  | GetUsagePlanCommandInput
  | GetUsagePlanKeyCommandInput
  | GetUsagePlanKeysCommandInput
  | GetUsagePlansCommandInput
  | GetVpcLinkCommandInput
  | GetVpcLinksCommandInput
  | ImportApiKeysCommandInput
  | ImportDocumentationPartsCommandInput
  | ImportRestApiCommandInput
  | PutGatewayResponseCommandInput
  | PutIntegrationCommandInput
  | PutIntegrationResponseCommandInput
  | PutMethodCommandInput
  | PutMethodResponseCommandInput
  | PutRestApiCommandInput
  | RejectDomainNameAccessAssociationCommandInput
  | TagResourceCommandInput
  | TestInvokeAuthorizerCommandInput
  | TestInvokeMethodCommandInput
  | UntagResourceCommandInput
  | UpdateAccountCommandInput
  | UpdateApiKeyCommandInput
  | UpdateAuthorizerCommandInput
  | UpdateBasePathMappingCommandInput
  | UpdateClientCertificateCommandInput
  | UpdateDeploymentCommandInput
  | UpdateDocumentationPartCommandInput
  | UpdateDocumentationVersionCommandInput
  | UpdateDomainNameCommandInput
  | UpdateGatewayResponseCommandInput
  | UpdateIntegrationCommandInput
  | UpdateIntegrationResponseCommandInput
  | UpdateMethodCommandInput
  | UpdateMethodResponseCommandInput
  | UpdateModelCommandInput
  | UpdateRequestValidatorCommandInput
  | UpdateResourceCommandInput
  | UpdateRestApiCommandInput
  | UpdateStageCommandInput
  | UpdateUsageCommandInput
  | UpdateUsagePlanCommandInput
  | UpdateVpcLinkCommandInput;
export type ServiceOutputTypes =
  | CreateApiKeyCommandOutput
  | CreateAuthorizerCommandOutput
  | CreateBasePathMappingCommandOutput
  | CreateDeploymentCommandOutput
  | CreateDocumentationPartCommandOutput
  | CreateDocumentationVersionCommandOutput
  | CreateDomainNameAccessAssociationCommandOutput
  | CreateDomainNameCommandOutput
  | CreateModelCommandOutput
  | CreateRequestValidatorCommandOutput
  | CreateResourceCommandOutput
  | CreateRestApiCommandOutput
  | CreateStageCommandOutput
  | CreateUsagePlanCommandOutput
  | CreateUsagePlanKeyCommandOutput
  | CreateVpcLinkCommandOutput
  | DeleteApiKeyCommandOutput
  | DeleteAuthorizerCommandOutput
  | DeleteBasePathMappingCommandOutput
  | DeleteClientCertificateCommandOutput
  | DeleteDeploymentCommandOutput
  | DeleteDocumentationPartCommandOutput
  | DeleteDocumentationVersionCommandOutput
  | DeleteDomainNameAccessAssociationCommandOutput
  | DeleteDomainNameCommandOutput
  | DeleteGatewayResponseCommandOutput
  | DeleteIntegrationCommandOutput
  | DeleteIntegrationResponseCommandOutput
  | DeleteMethodCommandOutput
  | DeleteMethodResponseCommandOutput
  | DeleteModelCommandOutput
  | DeleteRequestValidatorCommandOutput
  | DeleteResourceCommandOutput
  | DeleteRestApiCommandOutput
  | DeleteStageCommandOutput
  | DeleteUsagePlanCommandOutput
  | DeleteUsagePlanKeyCommandOutput
  | DeleteVpcLinkCommandOutput
  | FlushStageAuthorizersCacheCommandOutput
  | FlushStageCacheCommandOutput
  | GenerateClientCertificateCommandOutput
  | GetAccountCommandOutput
  | GetApiKeyCommandOutput
  | GetApiKeysCommandOutput
  | GetAuthorizerCommandOutput
  | GetAuthorizersCommandOutput
  | GetBasePathMappingCommandOutput
  | GetBasePathMappingsCommandOutput
  | GetClientCertificateCommandOutput
  | GetClientCertificatesCommandOutput
  | GetDeploymentCommandOutput
  | GetDeploymentsCommandOutput
  | GetDocumentationPartCommandOutput
  | GetDocumentationPartsCommandOutput
  | GetDocumentationVersionCommandOutput
  | GetDocumentationVersionsCommandOutput
  | GetDomainNameAccessAssociationsCommandOutput
  | GetDomainNameCommandOutput
  | GetDomainNamesCommandOutput
  | GetExportCommandOutput
  | GetGatewayResponseCommandOutput
  | GetGatewayResponsesCommandOutput
  | GetIntegrationCommandOutput
  | GetIntegrationResponseCommandOutput
  | GetMethodCommandOutput
  | GetMethodResponseCommandOutput
  | GetModelCommandOutput
  | GetModelTemplateCommandOutput
  | GetModelsCommandOutput
  | GetRequestValidatorCommandOutput
  | GetRequestValidatorsCommandOutput
  | GetResourceCommandOutput
  | GetResourcesCommandOutput
  | GetRestApiCommandOutput
  | GetRestApisCommandOutput
  | GetSdkCommandOutput
  | GetSdkTypeCommandOutput
  | GetSdkTypesCommandOutput
  | GetStageCommandOutput
  | GetStagesCommandOutput
  | GetTagsCommandOutput
  | GetUsageCommandOutput
  | GetUsagePlanCommandOutput
  | GetUsagePlanKeyCommandOutput
  | GetUsagePlanKeysCommandOutput
  | GetUsagePlansCommandOutput
  | GetVpcLinkCommandOutput
  | GetVpcLinksCommandOutput
  | ImportApiKeysCommandOutput
  | ImportDocumentationPartsCommandOutput
  | ImportRestApiCommandOutput
  | PutGatewayResponseCommandOutput
  | PutIntegrationCommandOutput
  | PutIntegrationResponseCommandOutput
  | PutMethodCommandOutput
  | PutMethodResponseCommandOutput
  | PutRestApiCommandOutput
  | RejectDomainNameAccessAssociationCommandOutput
  | TagResourceCommandOutput
  | TestInvokeAuthorizerCommandOutput
  | TestInvokeMethodCommandOutput
  | UntagResourceCommandOutput
  | UpdateAccountCommandOutput
  | UpdateApiKeyCommandOutput
  | UpdateAuthorizerCommandOutput
  | UpdateBasePathMappingCommandOutput
  | UpdateClientCertificateCommandOutput
  | UpdateDeploymentCommandOutput
  | UpdateDocumentationPartCommandOutput
  | UpdateDocumentationVersionCommandOutput
  | UpdateDomainNameCommandOutput
  | UpdateGatewayResponseCommandOutput
  | UpdateIntegrationCommandOutput
  | UpdateIntegrationResponseCommandOutput
  | UpdateMethodCommandOutput
  | UpdateMethodResponseCommandOutput
  | UpdateModelCommandOutput
  | UpdateRequestValidatorCommandOutput
  | UpdateResourceCommandOutput
  | UpdateRestApiCommandOutput
  | UpdateStageCommandOutput
  | UpdateUsageCommandOutput
  | UpdateUsagePlanCommandOutput
  | UpdateVpcLinkCommandOutput;
export interface ClientDefaults
  extends Partial<__SmithyConfiguration<__HttpHandlerOptions>> {
  requestHandler?: __HttpHandlerUserInput;
  sha256?: __ChecksumConstructor | __HashConstructor;
  urlParser?: __UrlParser;
  bodyLengthChecker?: __BodyLengthCalculator;
  streamCollector?: __StreamCollector;
  base64Decoder?: __Decoder;
  base64Encoder?: __Encoder;
  utf8Decoder?: __Decoder;
  utf8Encoder?: __Encoder;
  runtime?: string;
  disableHostPrefix?: boolean;
  serviceId?: string;
  useDualstackEndpoint?: boolean | __Provider<boolean>;
  useFipsEndpoint?: boolean | __Provider<boolean>;
  region?: string | __Provider<string>;
  profile?: string;
  defaultUserAgentProvider?: Provider<__UserAgent>;
  credentialDefaultProvider?: (input: any) => AwsCredentialIdentityProvider;
  maxAttempts?: number | __Provider<number>;
  retryMode?: string | __Provider<string>;
  logger?: __Logger;
  extensions?: RuntimeExtension[];
  defaultsMode?: __DefaultsMode | __Provider<__DefaultsMode>;
}
export type APIGatewayClientConfigType = Partial<
  __SmithyConfiguration<__HttpHandlerOptions>
> &
  ClientDefaults &
  UserAgentInputConfig &
  RetryInputConfig &
  RegionInputConfig &
  HostHeaderInputConfig &
  EndpointInputConfig<EndpointParameters> &
  HttpAuthSchemeInputConfig &
  ClientInputEndpointParameters;
export interface APIGatewayClientConfig extends APIGatewayClientConfigType {}
export type APIGatewayClientResolvedConfigType =
  __SmithyResolvedConfiguration<__HttpHandlerOptions> &
    Required<ClientDefaults> &
    RuntimeExtensionsConfig &
    UserAgentResolvedConfig &
    RetryResolvedConfig &
    RegionResolvedConfig &
    HostHeaderResolvedConfig &
    EndpointResolvedConfig<EndpointParameters> &
    HttpAuthSchemeResolvedConfig &
    ClientResolvedEndpointParameters;
export interface APIGatewayClientResolvedConfig
  extends APIGatewayClientResolvedConfigType {}
export declare class APIGatewayClient extends __Client<
  __HttpHandlerOptions,
  ServiceInputTypes,
  ServiceOutputTypes,
  APIGatewayClientResolvedConfig
> {
  readonly config: APIGatewayClientResolvedConfig;
  constructor(
    ...[configuration]: __CheckOptionalClientConfig<APIGatewayClientConfig>
  );
  destroy(): void;
}
