import {
  AwsSdkSigV4AuthInputConfig,
  AwsSdkSigV4AuthResolvedConfig,
  AwsSdkSigV4PreviouslyResolved,
} from "@aws-sdk/core";
import {
  HandlerExecutionContext,
  HttpAuthScheme,
  HttpAuthSchemeParameters,
  HttpAuthSchemeParametersProvider,
  HttpAuthSchemeProvider,
  Provider,
} from "@smithy/types";
import { APIGatewayClientResolvedConfig } from "../APIGatewayClient";
export interface APIGatewayHttpAuthSchemeParameters
  extends HttpAuthSchemeParameters {
  region?: string;
}
export interface APIGatewayHttpAuthSchemeParametersProvider
  extends HttpAuthSchemeParametersProvider<
    APIGatewayClientResolvedConfig,
    HandlerExecutionContext,
    APIGatewayHttpAuthSchemeParameters,
    object
  > {}
export declare const defaultAPIGatewayHttpAuthSchemeParametersProvider: (
  config: APIGatewayClientResolvedConfig,
  context: HandlerExecutionContext,
  input: object
) => Promise<APIGatewayHttpAuthSchemeParameters>;
export interface APIGatewayHttpAuthSchemeProvider
  extends HttpAuthSchemeProvider<APIGatewayHttpAuthSchemeParameters> {}
export declare const defaultAPIGatewayHttpAuthSchemeProvider: APIGatewayHttpAuthSchemeProvider;
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
  authSchemePreference?: string[] | Provider<string[]>;
  httpAuthSchemes?: HttpAuthScheme[];
  httpAuthSchemeProvider?: APIGatewayHttpAuthSchemeProvider;
}
export interface HttpAuthSchemeResolvedConfig
  extends AwsSdkSigV4AuthResolvedConfig {
  readonly authSchemePreference: Provider<string[]>;
  readonly httpAuthSchemes: HttpAuthScheme[];
  readonly httpAuthSchemeProvider: APIGatewayHttpAuthSchemeProvider;
}
export declare const resolveHttpAuthSchemeConfig: <T>(
  config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved
) => T & HttpAuthSchemeResolvedConfig;
