import { Command as $Command } from "@smithy/smithy-client";
import { MetadataBearer as __MetadataBearer } from "@smithy/types";
import { Uint8ArrayBlobAdapter } from "@smithy/util-stream";
import {
  APIGatewayClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../APIGatewayClient";
import { ExportResponse, GetExportRequest } from "../models/models_0";
export { __MetadataBearer };
export { $Command };
export interface GetExportCommandInput extends GetExportRequest {}
export type GetExportCommandOutputType = Pick<
  ExportResponse,
  Exclude<keyof ExportResponse, "body">
> & {
  body?: Uint8ArrayBlobAdapter;
};
export interface GetExportCommandOutput
  extends GetExportCommandOutputType,
    __MetadataBearer {}
declare const GetExportCommand_base: {
  new (
    input: GetExportCommandInput
  ): import("@smithy/smithy-client").CommandImpl<
    GetExportCommandInput,
    GetExportCommandOutput,
    APIGatewayClientResolvedConfig,
    ServiceInputTypes,
    ServiceOutputTypes
  >;
  new (
    input: GetExportCommandInput
  ): import("@smithy/smithy-client").CommandImpl<
    GetExportCommandInput,
    GetExportCommandOutput,
    APIGatewayClientResolvedConfig,
    ServiceInputTypes,
    ServiceOutputTypes
  >;
  getEndpointParameterInstructions(): import("@smithy/middleware-endpoint").EndpointParameterInstructions;
};
export declare class GetExportCommand extends GetExportCommand_base {
  protected static __types: {
    api: {
      input: GetExportRequest;
      output: ExportResponse;
    };
    sdk: {
      input: GetExportCommandInput;
      output: GetExportCommandOutput;
    };
  };
}
