import { Command as $Command } from "@smithy/smithy-client";
import { MetadataBearer as __MetadataBearer } from "@smithy/types";
import { Uint8ArrayBlobAdapter } from "@smithy/util-stream";
import {
  APIGatewayClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../APIGatewayClient";
import { GetSdkRequest, SdkResponse } from "../models/models_0";
export { __MetadataBearer };
export { $Command };
export interface GetSdkCommandInput extends GetSdkRequest {}
export type GetSdkCommandOutputType = Pick<
  SdkResponse,
  Exclude<keyof SdkResponse, "body">
> & {
  body?: Uint8ArrayBlobAdapter;
};
export interface GetSdkCommandOutput
  extends GetSdkCommandOutputType,
    __MetadataBearer {}
declare const GetSdkCommand_base: {
  new (input: GetSdkCommandInput): import("@smithy/smithy-client").CommandImpl<
    GetSdkCommandInput,
    GetSdkCommandOutput,
    APIGatewayClientResolvedConfig,
    ServiceInputTypes,
    ServiceOutputTypes
  >;
  new (input: GetSdkCommandInput): import("@smithy/smithy-client").CommandImpl<
    GetSdkCommandInput,
    GetSdkCommandOutput,
    APIGatewayClientResolvedConfig,
    ServiceInputTypes,
    ServiceOutputTypes
  >;
  getEndpointParameterInstructions(): import("@smithy/middleware-endpoint").EndpointParameterInstructions;
};
export declare class GetSdkCommand extends GetSdkCommand_base {
  protected static __types: {
    api: {
      input: GetSdkRequest;
      output: SdkResponse;
    };
    sdk: {
      input: GetSdkCommandInput;
      output: GetSdkCommandOutput;
    };
  };
}
