import { Command as $Command } from "@smithy/smithy-client";
import {
  BlobPayloadInputTypes,
  MetadataBearer as __MetadataBearer,
} from "@smithy/types";
import {
  APIGatewayClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../APIGatewayClient";
import { ApiKeyIds, ImportApiKeysRequest } from "../models/models_0";
export { __MetadataBearer };
export { $Command };
export type ImportApiKeysCommandInputType = Pick<
  ImportApiKeysRequest,
  Exclude<keyof ImportApiKeysRequest, "body">
> & {
  body: BlobPayloadInputTypes;
};
export interface ImportApiKeysCommandInput
  extends ImportApiKeysCommandInputType {}
export interface ImportApiKeysCommandOutput
  extends ApiKeyIds,
    __MetadataBearer {}
declare const ImportApiKeysCommand_base: {
  new (
    input: ImportApiKeysCommandInput
  ): import("@smithy/smithy-client").CommandImpl<
    ImportApiKeysCommandInput,
    ImportApiKeysCommandOutput,
    APIGatewayClientResolvedConfig,
    ServiceInputTypes,
    ServiceOutputTypes
  >;
  new (
    input: ImportApiKeysCommandInput
  ): import("@smithy/smithy-client").CommandImpl<
    ImportApiKeysCommandInput,
    ImportApiKeysCommandOutput,
    APIGatewayClientResolvedConfig,
    ServiceInputTypes,
    ServiceOutputTypes
  >;
  getEndpointParameterInstructions(): import("@smithy/middleware-endpoint").EndpointParameterInstructions;
};
export declare class ImportApiKeysCommand extends ImportApiKeysCommand_base {
  protected static __types: {
    api: {
      input: ImportApiKeysRequest;
      output: ApiKeyIds;
    };
    sdk: {
      input: ImportApiKeysCommandInput;
      output: ImportApiKeysCommandOutput;
    };
  };
}
