import { Command as $Command } from "@smithy/smithy-client";
import {
  BlobPayloadInputTypes,
  MetadataBearer as __MetadataBearer,
} from "@smithy/types";
import {
  APIGatewayClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../APIGatewayClient";
import {
  DocumentationPartIds,
  ImportDocumentationPartsRequest,
} from "../models/models_0";
export { __MetadataBearer };
export { $Command };
export type ImportDocumentationPartsCommandInputType = Pick<
  ImportDocumentationPartsRequest,
  Exclude<keyof ImportDocumentationPartsRequest, "body">
> & {
  body: BlobPayloadInputTypes;
};
export interface ImportDocumentationPartsCommandInput
  extends ImportDocumentationPartsCommandInputType {}
export interface ImportDocumentationPartsCommandOutput
  extends DocumentationPartIds,
    __MetadataBearer {}
declare const ImportDocumentationPartsCommand_base: {
  new (
    input: ImportDocumentationPartsCommandInput
  ): import("@smithy/smithy-client").CommandImpl<
    ImportDocumentationPartsCommandInput,
    ImportDocumentationPartsCommandOutput,
    APIGatewayClientResolvedConfig,
    ServiceInputTypes,
    ServiceOutputTypes
  >;
  new (
    input: ImportDocumentationPartsCommandInput
  ): import("@smithy/smithy-client").CommandImpl<
    ImportDocumentationPartsCommandInput,
    ImportDocumentationPartsCommandOutput,
    APIGatewayClientResolvedConfig,
    ServiceInputTypes,
    ServiceOutputTypes
  >;
  getEndpointParameterInstructions(): import("@smithy/middleware-endpoint").EndpointParameterInstructions;
};
export declare class ImportDocumentationPartsCommand extends ImportDocumentationPartsCommand_base {
  protected static __types: {
    api: {
      input: ImportDocumentationPartsRequest;
      output: DocumentationPartIds;
    };
    sdk: {
      input: ImportDocumentationPartsCommandInput;
      output: ImportDocumentationPartsCommandOutput;
    };
  };
}
