import { Command as $Command } from "@smithy/smithy-client";
import {
  BlobPayloadInputTypes,
  MetadataBearer as __MetadataBearer,
} from "@smithy/types";
import {
  APIGatewayClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../APIGatewayClient";
import { PutRestApiRequest, RestApi } from "../models/models_0";
export { __MetadataBearer };
export { $Command };
export type PutRestApiCommandInputType = Pick<
  PutRestApiRequest,
  Exclude<keyof PutRestApiRequest, "body">
> & {
  body: BlobPayloadInputTypes;
};
export interface PutRestApiCommandInput extends PutRestApiCommandInputType {}
export interface PutRestApiCommandOutput extends RestApi, __MetadataBearer {}
declare const PutRestApiCommand_base: {
  new (
    input: PutRestApiCommandInput
  ): import("@smithy/smithy-client").CommandImpl<
    PutRestApiCommandInput,
    PutRestApiCommandOutput,
    APIGatewayClientResolvedConfig,
    ServiceInputTypes,
    ServiceOutputTypes
  >;
  new (
    input: PutRestApiCommandInput
  ): import("@smithy/smithy-client").CommandImpl<
    PutRestApiCommandInput,
    PutRestApiCommandOutput,
    APIGatewayClientResolvedConfig,
    ServiceInputTypes,
    ServiceOutputTypes
  >;
  getEndpointParameterInstructions(): import("@smithy/middleware-endpoint").EndpointParameterInstructions;
};
export declare class PutRestApiCommand extends PutRestApiCommand_base {
  protected static __types: {
    api: {
      input: PutRestApiRequest;
      output: RestApi;
    };
    sdk: {
      input: PutRestApiCommandInput;
      output: PutRestApiCommandOutput;
    };
  };
}
