import {
  HttpRequest as __HttpRequest,
  HttpResponse as __HttpResponse,
} from "@smithy/protocol-http";
import { SerdeContext as __SerdeContext } from "@smithy/types";
import {
  CreateApiKeyCommandInput,
  CreateApiKeyCommandOutput,
} from "../commands/CreateApiKeyCommand";
import {
  CreateAuthorizerCommandInput,
  CreateAuthorizerCommandOutput,
} from "../commands/CreateAuthorizerCommand";
import {
  CreateBasePathMappingCommandInput,
  CreateBasePathMappingCommandOutput,
} from "../commands/CreateBasePathMappingCommand";
import {
  CreateDeploymentCommandInput,
  CreateDeploymentCommandOutput,
} from "../commands/CreateDeploymentCommand";
import {
  CreateDocumentationPartCommandInput,
  CreateDocumentationPartCommandOutput,
} from "../commands/CreateDocumentationPartCommand";
import {
  CreateDocumentationVersionCommandInput,
  CreateDocumentationVersionCommandOutput,
} from "../commands/CreateDocumentationVersionCommand";
import {
  CreateDomainNameAccessAssociationCommandInput,
  CreateDomainNameAccessAssociationCommandOutput,
} from "../commands/CreateDomainNameAccessAssociationCommand";
import {
  CreateDomainNameCommandInput,
  CreateDomainNameCommandOutput,
} from "../commands/CreateDomainNameCommand";
import {
  CreateModelCommandInput,
  CreateModelCommandOutput,
} from "../commands/CreateModelCommand";
import {
  CreateRequestValidatorCommandInput,
  CreateRequestValidatorCommandOutput,
} from "../commands/CreateRequestValidatorCommand";
import {
  CreateResourceCommandInput,
  CreateResourceCommandOutput,
} from "../commands/CreateResourceCommand";
import {
  CreateRestApiCommandInput,
  CreateRestApiCommandOutput,
} from "../commands/CreateRestApiCommand";
import {
  CreateStageCommandInput,
  CreateStageCommandOutput,
} from "../commands/CreateStageCommand";
import {
  CreateUsagePlanCommandInput,
  CreateUsagePlanCommandOutput,
} from "../commands/CreateUsagePlanCommand";
import {
  CreateUsagePlanKeyCommandInput,
  CreateUsagePlanKeyCommandOutput,
} from "../commands/CreateUsagePlanKeyCommand";
import {
  CreateVpcLinkCommandInput,
  CreateVpcLinkCommandOutput,
} from "../commands/CreateVpcLinkCommand";
import {
  DeleteApiKeyCommandInput,
  DeleteApiKeyCommandOutput,
} from "../commands/DeleteApiKeyCommand";
import {
  DeleteAuthorizerCommandInput,
  DeleteAuthorizerCommandOutput,
} from "../commands/DeleteAuthorizerCommand";
import {
  DeleteBasePathMappingCommandInput,
  DeleteBasePathMappingCommandOutput,
} from "../commands/DeleteBasePathMappingCommand";
import {
  DeleteClientCertificateCommandInput,
  DeleteClientCertificateCommandOutput,
} from "../commands/DeleteClientCertificateCommand";
import {
  DeleteDeploymentCommandInput,
  DeleteDeploymentCommandOutput,
} from "../commands/DeleteDeploymentCommand";
import {
  DeleteDocumentationPartCommandInput,
  DeleteDocumentationPartCommandOutput,
} from "../commands/DeleteDocumentationPartCommand";
import {
  DeleteDocumentationVersionCommandInput,
  DeleteDocumentationVersionCommandOutput,
} from "../commands/DeleteDocumentationVersionCommand";
import {
  DeleteDomainNameAccessAssociationCommandInput,
  DeleteDomainNameAccessAssociationCommandOutput,
} from "../commands/DeleteDomainNameAccessAssociationCommand";
import {
  DeleteDomainNameCommandInput,
  DeleteDomainNameCommandOutput,
} from "../commands/DeleteDomainNameCommand";
import {
  DeleteGatewayResponseCommandInput,
  DeleteGatewayResponseCommandOutput,
} from "../commands/DeleteGatewayResponseCommand";
import {
  DeleteIntegrationCommandInput,
  DeleteIntegrationCommandOutput,
} from "../commands/DeleteIntegrationCommand";
import {
  DeleteIntegrationResponseCommandInput,
  DeleteIntegrationResponseCommandOutput,
} from "../commands/DeleteIntegrationResponseCommand";
import {
  DeleteMethodCommandInput,
  DeleteMethodCommandOutput,
} from "../commands/DeleteMethodCommand";
import {
  DeleteMethodResponseCommandInput,
  DeleteMethodResponseCommandOutput,
} from "../commands/DeleteMethodResponseCommand";
import {
  DeleteModelCommandInput,
  DeleteModelCommandOutput,
} from "../commands/DeleteModelCommand";
import {
  DeleteRequestValidatorCommandInput,
  DeleteRequestValidatorCommandOutput,
} from "../commands/DeleteRequestValidatorCommand";
import {
  DeleteResourceCommandInput,
  DeleteResourceCommandOutput,
} from "../commands/DeleteResourceCommand";
import {
  DeleteRestApiCommandInput,
  DeleteRestApiCommandOutput,
} from "../commands/DeleteRestApiCommand";
import {
  DeleteStageCommandInput,
  DeleteStageCommandOutput,
} from "../commands/DeleteStageCommand";
import {
  DeleteUsagePlanCommandInput,
  DeleteUsagePlanCommandOutput,
} from "../commands/DeleteUsagePlanCommand";
import {
  DeleteUsagePlanKeyCommandInput,
  DeleteUsagePlanKeyCommandOutput,
} from "../commands/DeleteUsagePlanKeyCommand";
import {
  DeleteVpcLinkCommandInput,
  DeleteVpcLinkCommandOutput,
} from "../commands/DeleteVpcLinkCommand";
import {
  FlushStageAuthorizersCacheCommandInput,
  FlushStageAuthorizersCacheCommandOutput,
} from "../commands/FlushStageAuthorizersCacheCommand";
import {
  FlushStageCacheCommandInput,
  FlushStageCacheCommandOutput,
} from "../commands/FlushStageCacheCommand";
import {
  GenerateClientCertificateCommandInput,
  GenerateClientCertificateCommandOutput,
} from "../commands/GenerateClientCertificateCommand";
import {
  GetAccountCommandInput,
  GetAccountCommandOutput,
} from "../commands/GetAccountCommand";
import {
  GetApiKeyCommandInput,
  GetApiKeyCommandOutput,
} from "../commands/GetApiKeyCommand";
import {
  GetApiKeysCommandInput,
  GetApiKeysCommandOutput,
} from "../commands/GetApiKeysCommand";
import {
  GetAuthorizerCommandInput,
  GetAuthorizerCommandOutput,
} from "../commands/GetAuthorizerCommand";
import {
  GetAuthorizersCommandInput,
  GetAuthorizersCommandOutput,
} from "../commands/GetAuthorizersCommand";
import {
  GetBasePathMappingCommandInput,
  GetBasePathMappingCommandOutput,
} from "../commands/GetBasePathMappingCommand";
import {
  GetBasePathMappingsCommandInput,
  GetBasePathMappingsCommandOutput,
} from "../commands/GetBasePathMappingsCommand";
import {
  GetClientCertificateCommandInput,
  GetClientCertificateCommandOutput,
} from "../commands/GetClientCertificateCommand";
import {
  GetClientCertificatesCommandInput,
  GetClientCertificatesCommandOutput,
} from "../commands/GetClientCertificatesCommand";
import {
  GetDeploymentCommandInput,
  GetDeploymentCommandOutput,
} from "../commands/GetDeploymentCommand";
import {
  GetDeploymentsCommandInput,
  GetDeploymentsCommandOutput,
} from "../commands/GetDeploymentsCommand";
import {
  GetDocumentationPartCommandInput,
  GetDocumentationPartCommandOutput,
} from "../commands/GetDocumentationPartCommand";
import {
  GetDocumentationPartsCommandInput,
  GetDocumentationPartsCommandOutput,
} from "../commands/GetDocumentationPartsCommand";
import {
  GetDocumentationVersionCommandInput,
  GetDocumentationVersionCommandOutput,
} from "../commands/GetDocumentationVersionCommand";
import {
  GetDocumentationVersionsCommandInput,
  GetDocumentationVersionsCommandOutput,
} from "../commands/GetDocumentationVersionsCommand";
import {
  GetDomainNameAccessAssociationsCommandInput,
  GetDomainNameAccessAssociationsCommandOutput,
} from "../commands/GetDomainNameAccessAssociationsCommand";
import {
  GetDomainNameCommandInput,
  GetDomainNameCommandOutput,
} from "../commands/GetDomainNameCommand";
import {
  GetDomainNamesCommandInput,
  GetDomainNamesCommandOutput,
} from "../commands/GetDomainNamesCommand";
import {
  GetExportCommandInput,
  GetExportCommandOutput,
} from "../commands/GetExportCommand";
import {
  GetGatewayResponseCommandInput,
  GetGatewayResponseCommandOutput,
} from "../commands/GetGatewayResponseCommand";
import {
  GetGatewayResponsesCommandInput,
  GetGatewayResponsesCommandOutput,
} from "../commands/GetGatewayResponsesCommand";
import {
  GetIntegrationCommandInput,
  GetIntegrationCommandOutput,
} from "../commands/GetIntegrationCommand";
import {
  GetIntegrationResponseCommandInput,
  GetIntegrationResponseCommandOutput,
} from "../commands/GetIntegrationResponseCommand";
import {
  GetMethodCommandInput,
  GetMethodCommandOutput,
} from "../commands/GetMethodCommand";
import {
  GetMethodResponseCommandInput,
  GetMethodResponseCommandOutput,
} from "../commands/GetMethodResponseCommand";
import {
  GetModelCommandInput,
  GetModelCommandOutput,
} from "../commands/GetModelCommand";
import {
  GetModelsCommandInput,
  GetModelsCommandOutput,
} from "../commands/GetModelsCommand";
import {
  GetModelTemplateCommandInput,
  GetModelTemplateCommandOutput,
} from "../commands/GetModelTemplateCommand";
import {
  GetRequestValidatorCommandInput,
  GetRequestValidatorCommandOutput,
} from "../commands/GetRequestValidatorCommand";
import {
  GetRequestValidatorsCommandInput,
  GetRequestValidatorsCommandOutput,
} from "../commands/GetRequestValidatorsCommand";
import {
  GetResourceCommandInput,
  GetResourceCommandOutput,
} from "../commands/GetResourceCommand";
import {
  GetResourcesCommandInput,
  GetResourcesCommandOutput,
} from "../commands/GetResourcesCommand";
import {
  GetRestApiCommandInput,
  GetRestApiCommandOutput,
} from "../commands/GetRestApiCommand";
import {
  GetRestApisCommandInput,
  GetRestApisCommandOutput,
} from "../commands/GetRestApisCommand";
import {
  GetSdkCommandInput,
  GetSdkCommandOutput,
} from "../commands/GetSdkCommand";
import {
  GetSdkTypeCommandInput,
  GetSdkTypeCommandOutput,
} from "../commands/GetSdkTypeCommand";
import {
  GetSdkTypesCommandInput,
  GetSdkTypesCommandOutput,
} from "../commands/GetSdkTypesCommand";
import {
  GetStageCommandInput,
  GetStageCommandOutput,
} from "../commands/GetStageCommand";
import {
  GetStagesCommandInput,
  GetStagesCommandOutput,
} from "../commands/GetStagesCommand";
import {
  GetTagsCommandInput,
  GetTagsCommandOutput,
} from "../commands/GetTagsCommand";
import {
  GetUsageCommandInput,
  GetUsageCommandOutput,
} from "../commands/GetUsageCommand";
import {
  GetUsagePlanCommandInput,
  GetUsagePlanCommandOutput,
} from "../commands/GetUsagePlanCommand";
import {
  GetUsagePlanKeyCommandInput,
  GetUsagePlanKeyCommandOutput,
} from "../commands/GetUsagePlanKeyCommand";
import {
  GetUsagePlanKeysCommandInput,
  GetUsagePlanKeysCommandOutput,
} from "../commands/GetUsagePlanKeysCommand";
import {
  GetUsagePlansCommandInput,
  GetUsagePlansCommandOutput,
} from "../commands/GetUsagePlansCommand";
import {
  GetVpcLinkCommandInput,
  GetVpcLinkCommandOutput,
} from "../commands/GetVpcLinkCommand";
import {
  GetVpcLinksCommandInput,
  GetVpcLinksCommandOutput,
} from "../commands/GetVpcLinksCommand";
import {
  ImportApiKeysCommandInput,
  ImportApiKeysCommandOutput,
} from "../commands/ImportApiKeysCommand";
import {
  ImportDocumentationPartsCommandInput,
  ImportDocumentationPartsCommandOutput,
} from "../commands/ImportDocumentationPartsCommand";
import {
  ImportRestApiCommandInput,
  ImportRestApiCommandOutput,
} from "../commands/ImportRestApiCommand";
import {
  PutGatewayResponseCommandInput,
  PutGatewayResponseCommandOutput,
} from "../commands/PutGatewayResponseCommand";
import {
  PutIntegrationCommandInput,
  PutIntegrationCommandOutput,
} from "../commands/PutIntegrationCommand";
import {
  PutIntegrationResponseCommandInput,
  PutIntegrationResponseCommandOutput,
} from "../commands/PutIntegrationResponseCommand";
import {
  PutMethodCommandInput,
  PutMethodCommandOutput,
} from "../commands/PutMethodCommand";
import {
  PutMethodResponseCommandInput,
  PutMethodResponseCommandOutput,
} from "../commands/PutMethodResponseCommand";
import {
  PutRestApiCommandInput,
  PutRestApiCommandOutput,
} from "../commands/PutRestApiCommand";
import {
  RejectDomainNameAccessAssociationCommandInput,
  RejectDomainNameAccessAssociationCommandOutput,
} from "../commands/RejectDomainNameAccessAssociationCommand";
import {
  TagResourceCommandInput,
  TagResourceCommandOutput,
} from "../commands/TagResourceCommand";
import {
  TestInvokeAuthorizerCommandInput,
  TestInvokeAuthorizerCommandOutput,
} from "../commands/TestInvokeAuthorizerCommand";
import {
  TestInvokeMethodCommandInput,
  TestInvokeMethodCommandOutput,
} from "../commands/TestInvokeMethodCommand";
import {
  UntagResourceCommandInput,
  UntagResourceCommandOutput,
} from "../commands/UntagResourceCommand";
import {
  UpdateAccountCommandInput,
  UpdateAccountCommandOutput,
} from "../commands/UpdateAccountCommand";
import {
  UpdateApiKeyCommandInput,
  UpdateApiKeyCommandOutput,
} from "../commands/UpdateApiKeyCommand";
import {
  UpdateAuthorizerCommandInput,
  UpdateAuthorizerCommandOutput,
} from "../commands/UpdateAuthorizerCommand";
import {
  UpdateBasePathMappingCommandInput,
  UpdateBasePathMappingCommandOutput,
} from "../commands/UpdateBasePathMappingCommand";
import {
  UpdateClientCertificateCommandInput,
  UpdateClientCertificateCommandOutput,
} from "../commands/UpdateClientCertificateCommand";
import {
  UpdateDeploymentCommandInput,
  UpdateDeploymentCommandOutput,
} from "../commands/UpdateDeploymentCommand";
import {
  UpdateDocumentationPartCommandInput,
  UpdateDocumentationPartCommandOutput,
} from "../commands/UpdateDocumentationPartCommand";
import {
  UpdateDocumentationVersionCommandInput,
  UpdateDocumentationVersionCommandOutput,
} from "../commands/UpdateDocumentationVersionCommand";
import {
  UpdateDomainNameCommandInput,
  UpdateDomainNameCommandOutput,
} from "../commands/UpdateDomainNameCommand";
import {
  UpdateGatewayResponseCommandInput,
  UpdateGatewayResponseCommandOutput,
} from "../commands/UpdateGatewayResponseCommand";
import {
  UpdateIntegrationCommandInput,
  UpdateIntegrationCommandOutput,
} from "../commands/UpdateIntegrationCommand";
import {
  UpdateIntegrationResponseCommandInput,
  UpdateIntegrationResponseCommandOutput,
} from "../commands/UpdateIntegrationResponseCommand";
import {
  UpdateMethodCommandInput,
  UpdateMethodCommandOutput,
} from "../commands/UpdateMethodCommand";
import {
  UpdateMethodResponseCommandInput,
  UpdateMethodResponseCommandOutput,
} from "../commands/UpdateMethodResponseCommand";
import {
  UpdateModelCommandInput,
  UpdateModelCommandOutput,
} from "../commands/UpdateModelCommand";
import {
  UpdateRequestValidatorCommandInput,
  UpdateRequestValidatorCommandOutput,
} from "../commands/UpdateRequestValidatorCommand";
import {
  UpdateResourceCommandInput,
  UpdateResourceCommandOutput,
} from "../commands/UpdateResourceCommand";
import {
  UpdateRestApiCommandInput,
  UpdateRestApiCommandOutput,
} from "../commands/UpdateRestApiCommand";
import {
  UpdateStageCommandInput,
  UpdateStageCommandOutput,
} from "../commands/UpdateStageCommand";
import {
  UpdateUsageCommandInput,
  UpdateUsageCommandOutput,
} from "../commands/UpdateUsageCommand";
import {
  UpdateUsagePlanCommandInput,
  UpdateUsagePlanCommandOutput,
} from "../commands/UpdateUsagePlanCommand";
import {
  UpdateVpcLinkCommandInput,
  UpdateVpcLinkCommandOutput,
} from "../commands/UpdateVpcLinkCommand";
export declare const se_CreateApiKeyCommand: (
  input: CreateApiKeyCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateAuthorizerCommand: (
  input: CreateAuthorizerCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateBasePathMappingCommand: (
  input: CreateBasePathMappingCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateDeploymentCommand: (
  input: CreateDeploymentCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateDocumentationPartCommand: (
  input: CreateDocumentationPartCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateDocumentationVersionCommand: (
  input: CreateDocumentationVersionCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateDomainNameCommand: (
  input: CreateDomainNameCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateDomainNameAccessAssociationCommand: (
  input: CreateDomainNameAccessAssociationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateModelCommand: (
  input: CreateModelCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateRequestValidatorCommand: (
  input: CreateRequestValidatorCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateResourceCommand: (
  input: CreateResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateRestApiCommand: (
  input: CreateRestApiCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateStageCommand: (
  input: CreateStageCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateUsagePlanCommand: (
  input: CreateUsagePlanCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateUsagePlanKeyCommand: (
  input: CreateUsagePlanKeyCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_CreateVpcLinkCommand: (
  input: CreateVpcLinkCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteApiKeyCommand: (
  input: DeleteApiKeyCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteAuthorizerCommand: (
  input: DeleteAuthorizerCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteBasePathMappingCommand: (
  input: DeleteBasePathMappingCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteClientCertificateCommand: (
  input: DeleteClientCertificateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteDeploymentCommand: (
  input: DeleteDeploymentCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteDocumentationPartCommand: (
  input: DeleteDocumentationPartCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteDocumentationVersionCommand: (
  input: DeleteDocumentationVersionCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteDomainNameCommand: (
  input: DeleteDomainNameCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteDomainNameAccessAssociationCommand: (
  input: DeleteDomainNameAccessAssociationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteGatewayResponseCommand: (
  input: DeleteGatewayResponseCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteIntegrationCommand: (
  input: DeleteIntegrationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteIntegrationResponseCommand: (
  input: DeleteIntegrationResponseCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteMethodCommand: (
  input: DeleteMethodCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteMethodResponseCommand: (
  input: DeleteMethodResponseCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteModelCommand: (
  input: DeleteModelCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteRequestValidatorCommand: (
  input: DeleteRequestValidatorCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteResourceCommand: (
  input: DeleteResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteRestApiCommand: (
  input: DeleteRestApiCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteStageCommand: (
  input: DeleteStageCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteUsagePlanCommand: (
  input: DeleteUsagePlanCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteUsagePlanKeyCommand: (
  input: DeleteUsagePlanKeyCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_DeleteVpcLinkCommand: (
  input: DeleteVpcLinkCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_FlushStageAuthorizersCacheCommand: (
  input: FlushStageAuthorizersCacheCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_FlushStageCacheCommand: (
  input: FlushStageCacheCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GenerateClientCertificateCommand: (
  input: GenerateClientCertificateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetAccountCommand: (
  input: GetAccountCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetApiKeyCommand: (
  input: GetApiKeyCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetApiKeysCommand: (
  input: GetApiKeysCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetAuthorizerCommand: (
  input: GetAuthorizerCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetAuthorizersCommand: (
  input: GetAuthorizersCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetBasePathMappingCommand: (
  input: GetBasePathMappingCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetBasePathMappingsCommand: (
  input: GetBasePathMappingsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetClientCertificateCommand: (
  input: GetClientCertificateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetClientCertificatesCommand: (
  input: GetClientCertificatesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetDeploymentCommand: (
  input: GetDeploymentCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetDeploymentsCommand: (
  input: GetDeploymentsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetDocumentationPartCommand: (
  input: GetDocumentationPartCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetDocumentationPartsCommand: (
  input: GetDocumentationPartsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetDocumentationVersionCommand: (
  input: GetDocumentationVersionCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetDocumentationVersionsCommand: (
  input: GetDocumentationVersionsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetDomainNameCommand: (
  input: GetDomainNameCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetDomainNameAccessAssociationsCommand: (
  input: GetDomainNameAccessAssociationsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetDomainNamesCommand: (
  input: GetDomainNamesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetExportCommand: (
  input: GetExportCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetGatewayResponseCommand: (
  input: GetGatewayResponseCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetGatewayResponsesCommand: (
  input: GetGatewayResponsesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetIntegrationCommand: (
  input: GetIntegrationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetIntegrationResponseCommand: (
  input: GetIntegrationResponseCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetMethodCommand: (
  input: GetMethodCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetMethodResponseCommand: (
  input: GetMethodResponseCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetModelCommand: (
  input: GetModelCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetModelsCommand: (
  input: GetModelsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetModelTemplateCommand: (
  input: GetModelTemplateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetRequestValidatorCommand: (
  input: GetRequestValidatorCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetRequestValidatorsCommand: (
  input: GetRequestValidatorsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetResourceCommand: (
  input: GetResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetResourcesCommand: (
  input: GetResourcesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetRestApiCommand: (
  input: GetRestApiCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetRestApisCommand: (
  input: GetRestApisCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetSdkCommand: (
  input: GetSdkCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetSdkTypeCommand: (
  input: GetSdkTypeCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetSdkTypesCommand: (
  input: GetSdkTypesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetStageCommand: (
  input: GetStageCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetStagesCommand: (
  input: GetStagesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetTagsCommand: (
  input: GetTagsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetUsageCommand: (
  input: GetUsageCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetUsagePlanCommand: (
  input: GetUsagePlanCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetUsagePlanKeyCommand: (
  input: GetUsagePlanKeyCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetUsagePlanKeysCommand: (
  input: GetUsagePlanKeysCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetUsagePlansCommand: (
  input: GetUsagePlansCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetVpcLinkCommand: (
  input: GetVpcLinkCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_GetVpcLinksCommand: (
  input: GetVpcLinksCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ImportApiKeysCommand: (
  input: ImportApiKeysCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ImportDocumentationPartsCommand: (
  input: ImportDocumentationPartsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_ImportRestApiCommand: (
  input: ImportRestApiCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_PutGatewayResponseCommand: (
  input: PutGatewayResponseCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_PutIntegrationCommand: (
  input: PutIntegrationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_PutIntegrationResponseCommand: (
  input: PutIntegrationResponseCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_PutMethodCommand: (
  input: PutMethodCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_PutMethodResponseCommand: (
  input: PutMethodResponseCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_PutRestApiCommand: (
  input: PutRestApiCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_RejectDomainNameAccessAssociationCommand: (
  input: RejectDomainNameAccessAssociationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_TagResourceCommand: (
  input: TagResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_TestInvokeAuthorizerCommand: (
  input: TestInvokeAuthorizerCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_TestInvokeMethodCommand: (
  input: TestInvokeMethodCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UntagResourceCommand: (
  input: UntagResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateAccountCommand: (
  input: UpdateAccountCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateApiKeyCommand: (
  input: UpdateApiKeyCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateAuthorizerCommand: (
  input: UpdateAuthorizerCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateBasePathMappingCommand: (
  input: UpdateBasePathMappingCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateClientCertificateCommand: (
  input: UpdateClientCertificateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateDeploymentCommand: (
  input: UpdateDeploymentCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateDocumentationPartCommand: (
  input: UpdateDocumentationPartCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateDocumentationVersionCommand: (
  input: UpdateDocumentationVersionCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateDomainNameCommand: (
  input: UpdateDomainNameCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateGatewayResponseCommand: (
  input: UpdateGatewayResponseCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateIntegrationCommand: (
  input: UpdateIntegrationCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateIntegrationResponseCommand: (
  input: UpdateIntegrationResponseCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateMethodCommand: (
  input: UpdateMethodCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateMethodResponseCommand: (
  input: UpdateMethodResponseCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateModelCommand: (
  input: UpdateModelCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateRequestValidatorCommand: (
  input: UpdateRequestValidatorCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateResourceCommand: (
  input: UpdateResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateRestApiCommand: (
  input: UpdateRestApiCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateStageCommand: (
  input: UpdateStageCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateUsageCommand: (
  input: UpdateUsageCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateUsagePlanCommand: (
  input: UpdateUsagePlanCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const se_UpdateVpcLinkCommand: (
  input: UpdateVpcLinkCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const de_CreateApiKeyCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateApiKeyCommandOutput>;
export declare const de_CreateAuthorizerCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateAuthorizerCommandOutput>;
export declare const de_CreateBasePathMappingCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateBasePathMappingCommandOutput>;
export declare const de_CreateDeploymentCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateDeploymentCommandOutput>;
export declare const de_CreateDocumentationPartCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateDocumentationPartCommandOutput>;
export declare const de_CreateDocumentationVersionCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateDocumentationVersionCommandOutput>;
export declare const de_CreateDomainNameCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateDomainNameCommandOutput>;
export declare const de_CreateDomainNameAccessAssociationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateDomainNameAccessAssociationCommandOutput>;
export declare const de_CreateModelCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateModelCommandOutput>;
export declare const de_CreateRequestValidatorCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateRequestValidatorCommandOutput>;
export declare const de_CreateResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateResourceCommandOutput>;
export declare const de_CreateRestApiCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateRestApiCommandOutput>;
export declare const de_CreateStageCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateStageCommandOutput>;
export declare const de_CreateUsagePlanCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateUsagePlanCommandOutput>;
export declare const de_CreateUsagePlanKeyCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateUsagePlanKeyCommandOutput>;
export declare const de_CreateVpcLinkCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<CreateVpcLinkCommandOutput>;
export declare const de_DeleteApiKeyCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteApiKeyCommandOutput>;
export declare const de_DeleteAuthorizerCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteAuthorizerCommandOutput>;
export declare const de_DeleteBasePathMappingCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteBasePathMappingCommandOutput>;
export declare const de_DeleteClientCertificateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteClientCertificateCommandOutput>;
export declare const de_DeleteDeploymentCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteDeploymentCommandOutput>;
export declare const de_DeleteDocumentationPartCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteDocumentationPartCommandOutput>;
export declare const de_DeleteDocumentationVersionCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteDocumentationVersionCommandOutput>;
export declare const de_DeleteDomainNameCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteDomainNameCommandOutput>;
export declare const de_DeleteDomainNameAccessAssociationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteDomainNameAccessAssociationCommandOutput>;
export declare const de_DeleteGatewayResponseCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteGatewayResponseCommandOutput>;
export declare const de_DeleteIntegrationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteIntegrationCommandOutput>;
export declare const de_DeleteIntegrationResponseCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteIntegrationResponseCommandOutput>;
export declare const de_DeleteMethodCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteMethodCommandOutput>;
export declare const de_DeleteMethodResponseCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteMethodResponseCommandOutput>;
export declare const de_DeleteModelCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteModelCommandOutput>;
export declare const de_DeleteRequestValidatorCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteRequestValidatorCommandOutput>;
export declare const de_DeleteResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteResourceCommandOutput>;
export declare const de_DeleteRestApiCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteRestApiCommandOutput>;
export declare const de_DeleteStageCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteStageCommandOutput>;
export declare const de_DeleteUsagePlanCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteUsagePlanCommandOutput>;
export declare const de_DeleteUsagePlanKeyCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteUsagePlanKeyCommandOutput>;
export declare const de_DeleteVpcLinkCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteVpcLinkCommandOutput>;
export declare const de_FlushStageAuthorizersCacheCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<FlushStageAuthorizersCacheCommandOutput>;
export declare const de_FlushStageCacheCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<FlushStageCacheCommandOutput>;
export declare const de_GenerateClientCertificateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GenerateClientCertificateCommandOutput>;
export declare const de_GetAccountCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetAccountCommandOutput>;
export declare const de_GetApiKeyCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetApiKeyCommandOutput>;
export declare const de_GetApiKeysCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetApiKeysCommandOutput>;
export declare const de_GetAuthorizerCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetAuthorizerCommandOutput>;
export declare const de_GetAuthorizersCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetAuthorizersCommandOutput>;
export declare const de_GetBasePathMappingCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetBasePathMappingCommandOutput>;
export declare const de_GetBasePathMappingsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetBasePathMappingsCommandOutput>;
export declare const de_GetClientCertificateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetClientCertificateCommandOutput>;
export declare const de_GetClientCertificatesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetClientCertificatesCommandOutput>;
export declare const de_GetDeploymentCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetDeploymentCommandOutput>;
export declare const de_GetDeploymentsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetDeploymentsCommandOutput>;
export declare const de_GetDocumentationPartCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetDocumentationPartCommandOutput>;
export declare const de_GetDocumentationPartsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetDocumentationPartsCommandOutput>;
export declare const de_GetDocumentationVersionCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetDocumentationVersionCommandOutput>;
export declare const de_GetDocumentationVersionsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetDocumentationVersionsCommandOutput>;
export declare const de_GetDomainNameCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetDomainNameCommandOutput>;
export declare const de_GetDomainNameAccessAssociationsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetDomainNameAccessAssociationsCommandOutput>;
export declare const de_GetDomainNamesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetDomainNamesCommandOutput>;
export declare const de_GetExportCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetExportCommandOutput>;
export declare const de_GetGatewayResponseCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetGatewayResponseCommandOutput>;
export declare const de_GetGatewayResponsesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetGatewayResponsesCommandOutput>;
export declare const de_GetIntegrationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetIntegrationCommandOutput>;
export declare const de_GetIntegrationResponseCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetIntegrationResponseCommandOutput>;
export declare const de_GetMethodCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetMethodCommandOutput>;
export declare const de_GetMethodResponseCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetMethodResponseCommandOutput>;
export declare const de_GetModelCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetModelCommandOutput>;
export declare const de_GetModelsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetModelsCommandOutput>;
export declare const de_GetModelTemplateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetModelTemplateCommandOutput>;
export declare const de_GetRequestValidatorCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetRequestValidatorCommandOutput>;
export declare const de_GetRequestValidatorsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetRequestValidatorsCommandOutput>;
export declare const de_GetResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetResourceCommandOutput>;
export declare const de_GetResourcesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetResourcesCommandOutput>;
export declare const de_GetRestApiCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetRestApiCommandOutput>;
export declare const de_GetRestApisCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetRestApisCommandOutput>;
export declare const de_GetSdkCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetSdkCommandOutput>;
export declare const de_GetSdkTypeCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetSdkTypeCommandOutput>;
export declare const de_GetSdkTypesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetSdkTypesCommandOutput>;
export declare const de_GetStageCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetStageCommandOutput>;
export declare const de_GetStagesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetStagesCommandOutput>;
export declare const de_GetTagsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetTagsCommandOutput>;
export declare const de_GetUsageCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetUsageCommandOutput>;
export declare const de_GetUsagePlanCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetUsagePlanCommandOutput>;
export declare const de_GetUsagePlanKeyCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetUsagePlanKeyCommandOutput>;
export declare const de_GetUsagePlanKeysCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetUsagePlanKeysCommandOutput>;
export declare const de_GetUsagePlansCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetUsagePlansCommandOutput>;
export declare const de_GetVpcLinkCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetVpcLinkCommandOutput>;
export declare const de_GetVpcLinksCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetVpcLinksCommandOutput>;
export declare const de_ImportApiKeysCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ImportApiKeysCommandOutput>;
export declare const de_ImportDocumentationPartsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ImportDocumentationPartsCommandOutput>;
export declare const de_ImportRestApiCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ImportRestApiCommandOutput>;
export declare const de_PutGatewayResponseCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutGatewayResponseCommandOutput>;
export declare const de_PutIntegrationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutIntegrationCommandOutput>;
export declare const de_PutIntegrationResponseCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutIntegrationResponseCommandOutput>;
export declare const de_PutMethodCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutMethodCommandOutput>;
export declare const de_PutMethodResponseCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutMethodResponseCommandOutput>;
export declare const de_PutRestApiCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutRestApiCommandOutput>;
export declare const de_RejectDomainNameAccessAssociationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<RejectDomainNameAccessAssociationCommandOutput>;
export declare const de_TagResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<TagResourceCommandOutput>;
export declare const de_TestInvokeAuthorizerCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<TestInvokeAuthorizerCommandOutput>;
export declare const de_TestInvokeMethodCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<TestInvokeMethodCommandOutput>;
export declare const de_UntagResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UntagResourceCommandOutput>;
export declare const de_UpdateAccountCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateAccountCommandOutput>;
export declare const de_UpdateApiKeyCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateApiKeyCommandOutput>;
export declare const de_UpdateAuthorizerCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateAuthorizerCommandOutput>;
export declare const de_UpdateBasePathMappingCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateBasePathMappingCommandOutput>;
export declare const de_UpdateClientCertificateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateClientCertificateCommandOutput>;
export declare const de_UpdateDeploymentCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateDeploymentCommandOutput>;
export declare const de_UpdateDocumentationPartCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateDocumentationPartCommandOutput>;
export declare const de_UpdateDocumentationVersionCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateDocumentationVersionCommandOutput>;
export declare const de_UpdateDomainNameCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateDomainNameCommandOutput>;
export declare const de_UpdateGatewayResponseCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateGatewayResponseCommandOutput>;
export declare const de_UpdateIntegrationCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateIntegrationCommandOutput>;
export declare const de_UpdateIntegrationResponseCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateIntegrationResponseCommandOutput>;
export declare const de_UpdateMethodCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateMethodCommandOutput>;
export declare const de_UpdateMethodResponseCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateMethodResponseCommandOutput>;
export declare const de_UpdateModelCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateModelCommandOutput>;
export declare const de_UpdateRequestValidatorCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateRequestValidatorCommandOutput>;
export declare const de_UpdateResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateResourceCommandOutput>;
export declare const de_UpdateRestApiCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateRestApiCommandOutput>;
export declare const de_UpdateStageCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateStageCommandOutput>;
export declare const de_UpdateUsageCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateUsageCommandOutput>;
export declare const de_UpdateUsagePlanCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateUsagePlanCommandOutput>;
export declare const de_UpdateVpcLinkCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UpdateVpcLinkCommandOutput>;
